<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

// config
require_once 'config/config.inc';

// check install
require_once "lib/check_install.inc";

// Switch off the identifier of session
@ini_set('session.use_trans_sid', 0);

// Start a new session
session_start();

// Require necessary classes
require_once "class/class.exception_mysql.php";
require_once 'class/html_template/SeparateTemplate.php';

try
{
	// Require necessary libs
	require_once "lib/function.inc";
	require_once "lib/connect.inc";	
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

	$settings = $result->fetch_array();
	$result->close();
	
	include "templates/language/".$settings['language'].".inc";	
		
	$go_back = $settings['static'] == 1 ? "index.html" : "index.php";		

	$error = Array();

	$action = "";
	$action = $_POST["action"];

	if(!empty($action)){
		// Cut out a tags and a blanks
		$_POST["name"] = stripslashes(htmlspecialchars(trim($_POST["name"])));
		$_POST["email"] = strtolower(trim($_POST["email"]));
		$_POST["keywords"] = strtolower(htmlspecialchars(trim($_POST["keywords"])));
		$_POST["url"] = strtolower(trim($_POST["url"]));
		$_POST["reciprocal_link"] = trim($_POST["reciprocal_link"]);
		$_POST["description"] = stripslashes(htmlspecialchars(trim($_POST["description"])));
		$_POST["full_description"] = stripslashes(htmlspecialchars(trim($_POST["full_description"])));
		$_POST["htmlcode_banner"] = trim($_POST["htmlcode_banner"]);

		// Cut out http:// from url of site
		if(!empty($_POST["url"])){
			if(substr($_POST["url"], 0, 7) == "http://") { $_POST["url"] = str_replace('http://','',$_POST["url"]); }
			if(strpos($_POST["url"],'/')>0) { list($_POST["url"]) = explode('/',$_POST["url"]); }
		}

		// Cut out http:// from url address of reciprocal link
		if(!empty($_POST["reciprocal_link"]) and $settings['check_links'] == "yes"){
			if(substr(strtolower($_POST["reciprocal_link"]), 0, 7) == "http://") $_POST["reciprocal_link"] = str_replace('http://','',$_POST["reciprocal_link"]);
		}

		// Cut out all unnecessary tags and javascript from HTML code of banner
		$_POST["htmlcode_banner"] = cuttags($_POST["htmlcode_banner"]);

		// Check category is chosen, if not then print error
		if($_POST["id_cat"] == 0){
			$action = "";
			$error[] = MSG_ERROR_CHOOSE_CATEGORY;
		}

		// Check catalogue already has adding link, if it has then print error
		if(!empty($_POST["url"])){
			$src_url = $_POST["url"];
			if((substr($_POST["url"], 0, 4)) == "www.") $src_url = str_replace('www.','',$src_url);
			$src_url = str_replace('.','\\.',$src_url);

			$query = "SELECT * FROM ".DB_LINKS." WHERE url RLIKE '^(www\\.)?".$src_url."$' AND status = 'show' OR
																	url RLIKE '^(www\\.)?".$src_url."$' AND status = 'black'";
			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
			
			if($result->num_rows > 0){
				$action = "";
				$error[] = MSG_ERROR_EXIST_SITE;
			}

			$result->close();

			$query = "SELECT * FROM ".DB_LINKS." WHERE url RLIKE '^(www\\.)?".$src_url."$' AND status = 'new' OR
																	url RLIKE '^(www\\.)?".$src_url."$' AND status = 'hide'";

			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
			
			if($result->num_rows > 0){
				$action = "";
				$error[] = MSG_ERROR_AWAIT_CHECK;
			}

			$result->close();
		}

		// Check on, whether the adding site on the same hosting as catalogue is located
		if(!empty($_POST["url"]) and $settings['common_host'] == "yes"){
			if(common_host ($_POST["url"])){
				$action = "";
				$error[] = MSG_ERROR_SAME_HOSTING;
			}
		}

		// Check on, whether the url address of reciprocal link has the url address of catalogue in arg=value
		if((!empty($_POST["reciprocal_link"]) and $settings['check_get_parameter'] == "yes") and check_get_parameter ($_POST["reciprocal_link"])){
			$action = "";
			$error[] = MSG_ERROR_ARG_VALUE;
		}

		// Verify domen of reciprocal link and of catalogue
		if((!empty($_POST["reciprocal_link"]) and $settings['check_links'] == "yes") and native_check_link($_POST["reciprocal_link"],$_POST["url"])){
			$action = "";
			$error[] = MSG_ERROR_VERIFY_DOMEN;
		}

		// Check the email on valid
		if(!empty($_POST["email"]) and check_email($_POST["email"])){
			$action = "";
			$error[]= MSG_ERROR_WRONG_EMAIL;
		}

		// Check the url address on valid
		if(!empty($_POST["url"]) and check_url($_POST["url"])){
			$action = "";
			$error[]= MSG_ERROR_WRONG_URL;

			if(native_check_url($_POST["url"], $_SERVER["SERVER_NAME"])){
				$action = "";
				$error[] = MSG_ERROR_NOT_YOUR_SITE;
			}
		}

		// Check brief description of site on spaces
		if(!empty($_POST["description"]) and len_description($_POST["description"])){
			$action = "";
			$error[] = MSG_ERROR_BRIEF_DESC_SPACES;
		}

		// Count the number of characters of full description, if it more than a limit then print error
		if(!empty($_POST["full_description"]) and len_description($_POST["full_description"])){
			$action = "";
			$error[] = MSG_ERROR_FULL_DESC_SPACES;
		}

		// Check min and max number of characters in brief description
		if(!empty($_POST["description"]) and len_descriptionlink_min($_POST["description"], $settings['number_chars_description_min'])){
			$action = "";
			$error[] = str_replace('%NUMBER_CHARS_DESCRIPTION_MIN%', $settings['number_chars_description_min'], MSG_ERROR_BRIEF_DESC_MIN_CHAR);

			if (len_descriptionlink_max($_POST["description"], $settings['number_chars_description_max'])){
				$action = "";
				$error[] = str_replace('%NUMBER_CHARS_DESCRIPTION_MAX%', $settings['number_chars_description_max'], MSG_ERROR_BRIEF_DESC_MAX_CHAR);
			}
		}

		// Check min and max number of characters in full description
		if(!empty($_POST["full_description"])){
			
			if (len_full_description_min($_POST["full_description"], $settings['number_chars_fulldescription_min'])){
				$action = "";
				$error[] = str_replace('%NUMBER_CHARS_FULLDESCRIPTION_MIN%', $settings['number_chars_fulldescription_min'], MSG_ERROR_FULL_DESC_MIN_CHAR);
			}
			
			if (len_full_description_max($_POST["full_description"], $settings['number_chars_fulldescription_max'])){
				$action = "";
				$error[] = str_replace('%NUMBER_CHARS_FULLDESCRIPTION_MAX%', $settings['number_chars_fulldescription_max'], MSG_ERROR_FULL_DESC_MAX_CHAR);
			}
		}

		// Count the number of characters in HTML code of banner, if it more than a limit then print error
		if(!empty($_POST["htmlcode_banner"]) and len_htmlcode ($_POST["htmlcode_banner"],$settings['number_html_chars'])){
			$action = "";
			$error[] = str_replace('%NUMBER_HTML_CHARS%', $settings['number_html_chars'], MSG_ERROR_HTML_BANNER_LIMIT);
		}

		// if $settings['robot'] == yes then check on,
		// whether there's a prohibition on index of a reciprocal link by meta tag <meta name=robot>
		if((!empty($_POST["reciprocal_link"]) and $settings['check_links'] == "yes")){
			
			if(check_meta ($_POST["reciprocal_link"])){
				$action = "";
				$error[] = MSG_ERROR_CLOSE_INDEX_TAGS;
			}

			// check a directory if it is closed for index then print error
			if(check_robots ($_POST["reciprocal_link"])){
				$action = "";
				$error[] = MSG_ERROR_CLOSE_INDEX_DIR;
			}

			// if $settings['no_add_link'] == yes, check the number of links on the page of a reciprocal link
			// if the number of links is more than $settings['no_link'] print the notice
			if(($settings['no_add_link'] == "yes" and !empty($_POST["url"])) and count_link ($_POST["reciprocal_link"],$settings['number_reciprocal_links_limit']) ){
				$action = "";
				$error[] = str_replace('%NUMBER_RECIPROCAL_LINKS_LIMIT%', $settings['number_reciprocal_links_limit'], MSG_ERROR_NUMBER_URL);
			}
		}		

		// Verify captcha
		if(!empty($_POST["securityCode"]) and $settings['request_captcha'] == "yes"){
			$query = "SELECT securityCode FROM ".DB_CAPTCHA." WHERE id_session = '".session_id()."'";
			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error,$insert,"Error executing SQL query!"); }

			$row = $result->fetch_array();

			$result->close();

			if(trim($_POST['securityCode']) != $row['securityCode']){
				$action = "";
				$error[] = MSG_ERROR_WRONG_CAPTCHA;
			}
		}

		// If $settings['check_links'] == yes, then check
		// the find a reciprocal link on our site
		if(!empty($_POST["reciprocal_link"]) and $settings['check_links'] == "yes"){
			if(check_url_link ($_POST["reciprocal_link"], $settings['url'])){			
				$action = "";
				$error[] = MSG_ERROR_NOT_RECIPROCAL_LINK;	
			}		
		}

		// Check HTML code of banner on valid
		if(!empty($_POST["htmlcode_banner"])){
			// check htmlcode of banner
			if (check_htmlcode_banner($_POST["htmlcode_banner"])){
				$action = "";
				$error[] = MSG_ERROR_WRONG_HTML_BANNER;
			}
			else{
				// check image size of banner
				if (check_size_banner($_POST["htmlcode_banner"])){
					$action = "";
					$error[] = MSG_ERROR_SIZE_BANNER;
				}

				// check image type of banner
				if(check_type_image_banner($_POST["htmlcode_banner"])){
					$action = "";
					$error[] = MSG_ERROR_TYPE_BANNER;
				}
			}
		}

		// Check all required fields is filled
		// Check site name, if its value is empty print error
		if(empty($_POST["name"])){
			$action = "";
			$error[] = MSG_ERROR_NOT_FILLED_NAME;
		}

		// Check site address, if its value is empty print error
		if(empty($_POST["url"])){
			$action  = "";
			$error[] = MSG_ERROR_NOT_FILLED_URL;
		}

		// Check reciprocal link, if its value is empty print error
		if($settings['check_links'] == "yes" and empty($_POST["reciprocal_link"])){
			$action = "";
			$error[] = MSG_ERROR_NOT_FILLED_RECIPROCAL_LINK; 
		}

		// Check email, if its value is empty print error
		if(empty($_POST["email"])){
			$action = "";
			$error[] = MSG_ERROR_NOT_FILLED_EMAIL;
		}

		// Check description of link, if its value is empty print error
		if(empty($_POST["description"])){
			$action = "";
			$error[] = MSG_ERROR_NOT_FILLED_BRIEF_DESC;
		}

		// Check CAPTCHA, if its value is empty print error
		if(empty($_POST["securityCode"]) and $settings['request_captcha'] == "yes"){
			$action = "";
			$error[] = MSG_ERROR_NOT_FILLED_CAPTCHA;
		}

		// Check full description of link, if its value is empty print error
		if(empty($_POST["full_description"])){
			$action = "";
			$error[] = MSG_ERROR_NOT_FILLED_FULL_DESC;
		}

		// Shield a special characters
		$_POST["name"] = $dbh->real_escape_string($_POST["name"]);
		$_POST["email"] = $dbh->real_escape_string($_POST["email"]);
		$_POST["keywords"] = $dbh->real_escape_string($_POST["keywords"]);
		$_POST["url"] = $dbh->real_escape_string($_POST["url"]);
		$_POST["reciprocal_link"] = $dbh->real_escape_string($_POST["reciprocal_link"]);
		$_POST["description"] = $dbh->real_escape_string($_POST["description"]);
		$_POST["full_description"] = $dbh->real_escape_string($_POST["full_description"]);
		$_POST["htmlcode_banner"] = $dbh->real_escape_string($_POST["htmlcode_banner"]);
		$_POST["id_cat"] = $dbh->real_escape_string($_POST["id_cat"]);	

		// Add the link if there are not any errors
		if(count($error) == 0){
			$status	= $settings['add_links_without_check'] == "yes" ? 'show' : 'new';
			$token = getRandomCode();

			// Form the SQL query to add link
			$insert = "INSERT INTO ".DB_LINKS." (`id_link`,`name`,`url`,`reciprocal_link`,`time`,`time_check`,`email`,`keywords`,`description`,`full_description`,`htmlcode_banner`,`id_cat`,`status`,`token`,`check_link`,`count`,`reason`)
						VALUES (0,
						'".$_POST['name']."',
						'".$_POST['url']."',
						'".$_POST['reciprocal_link']."',
						now(),
						'0000-00-00 00:00:00',
						'".$_POST['email']."',
						'".$_POST['keywords']."',
						'".$_POST['description']."',
						'".$_POST['full_description']."',
						'".$_POST['htmlcode_banner']."',
						".$_POST['id_cat'].",
						'".$status."',
						'".$token."',
						'yes',
						0,
						'');";
								
			$result = $dbh->query($insert);

			if(!$result) { throw new ExceptionMySQL($dbh->error,$insert,"Error executing SQL query!"); }

			// Notify user about his link was added to check's turn
			$id = $result->insert_id;

			if($settings['static'] == 1) 
				$adr = 'http://'.$_SERVER['SERVER_NAME'].root().'link_'.$id.'.html'; 
			else 
				$adr = 'http://'.$_SERVER['SERVER_NAME'].root().'index.php?id_link='.$id.''; 

			$date = date("d.m.Y г. G:i:s");

			$msgUser = $settings['template_mail_1'];
			$msgUser = str_replace("{[HTTP_HOST]}", $_SERVER['SERVER_NAME'], $msgUser);
			$msgUser = str_replace("{[ADRESS]}", $adr, $msgUser);
			$msgUser = str_replace("{[NAME]}", $_POST["name"], $msgUser);
			$msgUser = str_replace("{[EMAIL]}", $_POST["email"], $msgUser);
			$msgUser = str_replace("{[URL]}", $_POST["url"], $msgUser);
			$msgUser = str_replace("{[DESCRIPTION]}", $_POST["description"], $msgUser);
			$msgUser = str_replace("{[DATE]}", $date, $msgUser);

			$fromname = $_SERVER['SERVER_NAME'];
			$fromname_encoded = base64_encode($fromname);
			$fromname_packed = "=?utf-8?B?".$fromname_encoded."?=";
			$fromaddr  = $settings['email'];

			$headers = "MIME-Version: 1.0\n";
			$headers .= "From: ".$fromname_packed." <$fromaddr>\n";
			$headers .= "Content-type: text/plain; charset=utf-8\n";
			$headers .= "Content-Transfer-Encoding: 8bit\r\n";

			if($settings['add_links_without_check'] == 'no') { @mail($_POST["email"], STR_SUBJECT_WAIT, $msgUser, $headers); }

			// Notify admin of catalogue about a new link
			if($settings['new_links_notification'] == "yes"){
				$msgAdmin = $settings['template_mail_5'];
				$msgAdmin = str_replace("{[HTTP_HOST]}", $HTTP_HOST, $msgAdmin);
				$msgAdmin = str_replace("{[NAME]}", $_POST["name"], $msgAdmin);
				$msgAdmin = str_replace("{[EMAIL]}", $_POST["email"], $msgAdmin);
				$msgAdmin = str_replace("{[URL]}", $_POST["url"], $msgAdmin);
				$msgAdmin = str_replace("{[DESCRIPTION]}", $_POST["description"], $msgAdmin);
				$msgAdmin = str_replace("{[DATE]}", $date, $msgAdmin);

				@mail($settings['email'], STR_SUBJECT_NEWLINK, $msgAdmin, $headers);
			}

			// print the message if the SQL query was executed successfully
			// header
			require "nulltop.php";

			echo "<center><p class=msg>".$settings['from_add_message']."</p><br /><br />";
			echo "<a href=add_url.php>".STR_ADD_MORE_LINK."</a><br /><br />";
			echo "<a href=".$go_back.">".STR_GO_BACK."</a></center><br />";

			// footer
			require "nullbottom.php";

			$dbh->close();

			exit();
		}
	}

	if(empty($action)){
		$rules = nl2br(htmlspecialchars($settings['rules']));

		// Print th elist of catalogues and subcatalogues
		$query = "SELECT * FROM ".DB_CATALOG." ORDER BY name";
		$result = $dbh->query($query);

		if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

		$arraycat = Array();
		$array_id_parent = Array();

		while($list = $result->fetch_array())
		{
			$arraycat[] = array($list['name'], $list['id_cat'],$list['id_parent']);
			$array_id_parent[] = $list['id_parent'];
		}

		$result->close();		

		// include template
		$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/add_url.tpl");

		// header
		$tpl->assign('METATITLE', TITLEPAGE);
		$tpl->assign('METADESCRIPTION', DESCRIPTIONPAGE);
		$tpl->assign('METAKEYWORDS', KEYWORDS);
		$tpl->assign('VERSION', $version);		

		$tpl->assign('STR_GO_TO_CATALOG', STR_GO_TO_CATALOG);		
		$tpl->assign('STR_HTMLCODE_BANNER', STR_HTMLCODE_BANNER);	

		$tpl->assign('ALERT_INITIAALIZATION_ERROR_INTERFACE', ALERT_INITIAALIZATION_ERROR_INTERFACE);
		
		//form
		$tpl->assign('ACTION',$_SERVER['PHP_SELF']);		
		$tpl->assign('STR_REQUIRED_FIELD', STR_REQUIRED_FIELD);		
		$tpl->assign('STR_CHOOSE_YOUR_CATEGORY', STR_CHOOSE_YOUR_CATEGORY);		
		$tpl->assign('STR_CHOOSE_CATEGORY', STR_CHOOSE_CATEGORY);	
		$tpl->assign('STR_FORM_NAME', STR_FORM_NAME);	
		$tpl->assign('STR_FORM_URL', STR_FORM_URL);		
		$tpl->assign('STR_FORM_EMAIL', STR_FORM_EMAIL);				
		$tpl->assign('STR_FORM_KEYWORDS', STR_FORM_KEYWORDS);		
		$tpl->assign('STR_SEPARATED_BY_COMMAS', STR_SEPARATED_BY_COMMAS);		
		$tpl->assign('STR_FORM_DESCRIPTION', STR_FORM_DESCRIPTION);				
		$tpl->assign('STR_ONLY_TEXT_NOT_HTMLCODE', STR_ONLY_TEXT_NOT_HTMLCODE);		
		$tpl->assign('STR_FROM', STR_FROM);
		$tpl->assign('STR_TO', STR_TO);	
		$tpl->assign('STR_IF_ANY', STR_IF_ANY);
		$tpl->assign('STR_NO_MORE', STR_NO_MORE);
		$tpl->assign('STR_CHARACTERS', STR_CHARACTERS);		
		$tpl->assign("STR_FORM_FULL_DESCRIPTION", STR_FORM_FULL_DESCRIPTION);		
		$tpl->assign("STR_LEFT", STR_LEFT);		
		$tpl->assign("STR_FROM_TOTAL", STR_FROM_TOTAL);		
		$tpl->assign("STR_HTML_CODE_BANNER", STR_HTML_CODE_BANNER);
		$tpl->assign("BUTTON_ADD", BUTTON_ADD);		
		$tpl->assign("BUTTON_RESET", BUTTON_RESET);	
		$tpl->assign("STR_SCRIPT_LINK_CATALOG", STR_SCRIPT_LINK_CATALOG);
		
		$tpl->assign('GO_BACK',$go_back);		

		// Print HTML code of site
		if(!empty($settings['htmlcode_site1']) OR !empty($settings['htmlcode_site2']) OR !empty($settings['htmlcode_site3'])){
			$tpl->assign("STR_HTML_CODE_OF_LINK_FOR_THIS",STR_HTML_CODE_OF_LINK_FOR_THIS);
		}

		if(!empty($settings['htmlcode_site1'])){
			$tpl->assign("HTMLCODE_SITE1", $settings['htmlcode_site1']);
		}

		if(!empty($settings['htmlcode_site2'])){
			$tpl->assign("HTMLCODE_SITE2", $settings['htmlcode_site2']);
		}

		if(!empty($settings['htmlcode_site3'])){
			$tpl->assign("HTMLCODE_SITE3", $settings['htmlcode_site3']);
		}

		// Print HTML code of banner
		if(!empty($settings['htmlcode_banner1']) OR !empty($settings['htmlcode_banner2']) OR !empty($settings['htmlcode_banner3'])){
			$tpl->assign("STR_HTML_CODE_OF_BANNER_FOR_THIS", STR_HTML_CODE_OF_BANNER_FOR_THIS);
			$tpl->assign("STR_HTMLCODE_BANNER", STR_HTMLCODE_BANNER);
		}

		if(!empty($settings['htmlcode_banner1'])){
			$tpl->assign("HTMLCODE_BANNER1", $settings['htmlcode_banner1']);
		}
		
		if(!empty($settings['htmlcode_banner2'])){
			$tpl->assign("HTMLCODE_BANNER2", $settings['htmlcode_banner2']);
		}		
		
		if(!empty($settings['htmlcode_banner3'])){
			$tpl->assign("HTMLCODE_BANNER3", $settings['htmlcode_banner3']);
		}
		
		if(!empty($settings['rules'])){
			$tpl->assign("RULES", $settings['rules']);
			$tpl->assign("STR_RULES", STR_RULES);
		}		
		
		$tpl->assign("OPTION", ShowTree(0,0));
		$tpl->assign("ID_CAT", $_POST['id_cat']);		
		$tpl->assign("NAME", $_POST['name']);	
		$tpl->assign("URL", $_POST['url']);		
		
		if($settings['check_links'] == "yes") {
			$tpl->assign("STR_FORM_RECIPROCAL_LINK", STR_FORM_RECIPROCAL_LINK);			
		}			
		
		$tpl->assign("RECIPROCAL_LINK", $_POST['reciprocal_link']);		
		$tpl->assign("EMAIL", $_POST['email']);		
		$tpl->assign("KEYWORDS", $_POST['keywords']);		
		$tpl->assign("DESCRIPTION", $_POST['description']);		
		$tpl->assign("FULL_DESCRIPTION", $_POST['full_description']);		
		$tpl->assign("HTMLCODE_BANNER", $_POST['htmlcode_banner']);	
		$tpl->assign("NUMBER_CHARS_DESCRIPTION_MIN", $settings['number_chars_description_min']);		
		$tpl->assign("NUMBER_CHARS_DESCRIPTION_MAX", $settings['number_chars_description_max']);
		$tpl->assign("NUMBER_CHARS_FULLDESCRIPTION_MIN", $settings['number_chars_fulldescription_min']);
		$tpl->assign("NUMBER_CHARS_FULLDESCRIPTION_MAX", $settings['number_chars_fulldescription_max']);
		$tpl->assign("NUMBER_HTML_CHARS", $settings['number_html_chars']);
	
		if($settings['request_captcha'] == "yes"){
			$tpl->assign("SESSION_ID", session_id());
			$tpl->assign("STR_FORM_SECURITYCODE", STR_FORM_SECURITYCODE);
		}
		
		if(count($error) > 0){
			$errorBlock = $tpl->fetch('show_errors');		
			$errorBlock->assign('STR_IDENTIFIED_FOLLOWING_ERRORS', STR_IDENTIFIED_FOLLOWING_ERRORS);
		
			foreach($error as $row){
				$rowBlock = $errorBlock->fetch('row');
				$rowBlock->assign('ERROR', $row);
				$errorBlock->assign('row', $rowBlock);
			}
		
			$tpl->assign('show_errors', $errorBlock);
		}

		$tpl->assign('STR_LOGO', STR_LOGO);
		$tpl->assign('STR_AUTHOR', STR_AUTHOR);

		// print html page
		$tpl->display();

		$dbh->close();
	}
}
catch(ExceptionMySQL $exc)
{
	require_once("lib/exception_mysql_debug.inc");
}

?>
