<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

ob_start();

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();	
	
	// include template
	include "templates/language/".$settings['language'].".inc";	

	// Authenticate
	require "../lib/authenticate.inc";

	$error = Array();

	if(!empty($_POST["action"])){
		$_POST['name'] = htmlspecialchars(trim($_POST['name']));
		$_POST['description'] = trim($_POST['description']);
		$_POST['keywords'] = trim($_POST['keywords']);
		
		// Shield a special characters	
		$_POST['name'] = $dbh->real_escape_string($_POST['name']);
		$_POST['description'] = $dbh->real_escape_string($_POST['description']);
		$_POST['keywords'] = $dbh->real_escape_string($_POST['keywords']);
		$_POST['id_parent'] = $dbh->real_escape_string($_POST['id_parent']);		

		// Check empty a name of category
		if(empty($_POST['name'])){
			$error[] = MSG_ERROR_FILL_CAT_NAME;
		}

		if(!empty($_FILES["image"]["name"])){
			$size = filesize ($_FILES['image']['tmp_name']);
			
			if($size / 1024 > 100){			
				$error[] = str_replace('%LIMIT%','50',MSG_ERROR_FILESIZE);	
			}			
		}

		// Form SQL query on added a new category
		if(empty($error)){
			if(!empty($_FILES['image']['tmp_name'])){		
				$ext = strrchr($_FILES["image"]["name"], ".");

				if(preg_match('/\.(jpg|jpeg|png|gif)$/i', $ext)){			
					$tmp = $_FILES['image']['tmp_name'];
					$original = file_get_contents($tmp);
					$image_mime = $_FILES["image"]["type"];
					$image = $dbh->real_escape_string(image_convert($original, 80, 80, $image_mime));					
				}
			}
		
			$insert = "INSERT INTO ".DB_CATALOG." (`id_cat`,`name`,`description`,`keywords`,`image`,`image_mime`,`id_parent`) VALUES (0,'".$_POST['name']."','".$_POST['description']."','".$_POST['keywords']."', '".$image."', '".$image_mime."', ".$_POST['id_parent'].");";
			$result = $dbh->query($insert);

			if(!$result) throw new ExceptionMySQL($dbh->error,$insert,"Error executing SQL query!");
			
			$dbh->close();

			// Return to main page if query is executed successfully
			header("Location: category.php?id_parent=".$_POST['id_parent']);
			exit; 
		}
	}
	
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/addcategory.tpl");
		
	//header
	include "header.inc";
		
	$tpl->assign('TITLE', TITLEADMIN_ADD_CATEGORY);
	$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_ADD_CATEGORY);	
	$tpl->assign('HELP', INFOADMIN_ADD_CATEGORY);		
	
	if(count($error) > 0){
		$errorBlock = $tpl->fetch('show_errors');
		$errorBlock->assign('STR_IDENTIFIED_FOLLOWING_ERRORS', STR_IDENTIFIED_FOLLOWING_ERRORS);
		$errorBlock->assign('MSG_ERROR_FILL_CAT_NAME', MSG_ERROR_FILL_CAT_NAME);
		$errorBlock->assign('MSG_ERROR_FILESIZE', MSG_ERROR_FILESIZE);
			
		foreach($error as $row){
			$rowBlock = $errorBlock->fetch('row');
			$rowBlock->assign('ERROR', $row);
			$errorBlock->assign('row', $rowBlock);
		}
		
		$tpl->assign('show_errors', $errorBlock);
	}
		
	// menu
	include "menu.inc";		
		
	//FORM
	$tpl->assign('STR_REQUIRED_FIELDS', STR_REQUIRED_FIELDS);	
	$tpl->assign('STR_GO_BACK', STR_GO_BACK);
	$tpl->assign('STR_NO', STR_NO);
	$tpl->assign('STR_CATEGORY_NAME', STR_CATEGORY_NAME);		
	$tpl->assign('STR_CATEGORY_DESCRIPTION', STR_CATEGORY_DESCRIPTION);
	$tpl->assign('STR_CATEGORY_KEYWORDS', STR_CATEGORY_KEYWORDS);		
	$tpl->assign('STR_CATEGORY', STR_CATEGORY);		
	$tpl->assign('STR_CATEGORY_IMAGE', STR_CATEGORY_IMAGE);		
	$tpl->assign('STR_REMOVE_PIC', STR_REMOVE_PIC);		
		
	//value
	$tpl->assign('PHP_SELF', $_SERVER['PHP_SELF']);		
	$tpl->assign('NAME', $_POST['name']);		
	$tpl->assign('DESCRIPTION', $_POST['description']);		
	$tpl->assign('KEYWORDS', $_POST['keywords']);		
	$tpl->assign('FREEZ', 'yes');	

	$tpl->assign('ID_PARENT', $_GET['id_parent']);
	$tpl->assign('BUTTON', STR_ADD);
		
	//footer
	include "footer.inc";
		
	// Count a quantity of the links
	$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
		
	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
		
	$total = $result->fetch_assoc();

	// Clear the descriptor
	$result->close();
		
	$tpl->assign("TOTAL_LINKS",$total['COUNT(*)']);	
	$tpl->assign("STR_HELP", STR_HELP);
		
	// print html page
	$tpl->display();		

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>