<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";
require_once "../class/class.update.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";

	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();	
	
	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";

	$update = new Update();
	
	if($update->checkNewVersion($version)){
		header('Content-Type: application/xml; charset=utf-8');

		$update_warning = STR_UPDATE_WARNING;
	
		$update_warning = str_replace('%SCRIPTNAME%', 'My Links Manager', $update_warning);
		$update_warning = str_replace('%VERSION%', $update->getVersion(), $update_warning);
		$update_warning = str_replace('%CREATED%', $update->getCreated(), $update_warning);
		$update_warning = str_replace('%DOWNLOADLINK%', $update->getDownloadLink(), $update_warning);	
	
		echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		echo "<DOCUMENT>\n";
		echo "<warning>".htmlspecialchars($update_warning)."</warning>\n";
		echo "</DOCUMENT>";	
	}
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>