<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

ob_start();

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";
	
	$_POST['id_link'] = $dbh->real_escape_string($_POST['id_link']);
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();	
	
	// include template
	include "templates/language/".$settings['language'].".inc";	

	// Authenticate
	require "../lib/authenticate.inc";

	if(!empty($_POST["action"])){
		// Remove links
		if($_POST['event'] == "delete"){
			$_POST['id_link'] = $dbh->real_escape_string($_POST['id_link']);
		
			$delete = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];

			if($dbh->query($delete)){
				$success = MSG_LINK_REMOVED;
			}
			else { throw new ExceptionMySQL($dbh->error,$delete,"Error executing SQL query!"); }
		}

		if($_POST['event'] == "restore"){
			// From SQL query on update data
			$update = "UPDATE ".DB_LINKS." SET status = 'show', time = NOW(), number_check = 0, reason = '' WHERE id_link = ".$_POST['id_link'];

			if($dbh->query($update)){
				$success = MSG_LINK_RESTORED;
			}
			else { throw new ExceptionMySQL($dbh->error,$update,"Error executing SQL query!"); }
		}
	}		

	//
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/blacklist.tpl");
	
	//header
	include "header.inc";	
		
	$tpl->assign('TITLE', TITLEADMIN_BLACKLIST);
	$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_BLACKLIST);		
	$tpl->assign('HELP', INFO_BLACKLIST);		
		
	//alert
	if(!empty($success)){ 
		$tpl->assign('MSG_ALERT', $success);
	}		
			
	// menu
	include "menu.inc";		

	// Element of pagination
	$all_number_links = $settings['all_number_links'] ? $settings['all_number_links'] : 5;	
			
	$page = $_GET['page'];
	if(empty($page)) $page = 1;
	$begin = ($page - 1) * $all_number_links;

	$query = "SELECT *,c.name AS catname, l.description AS descriptioN FROM ".DB_LINKS." l LEFT JOIN ".DB_CATALOG." c ON c.id_cat = l.id_cat
                    WHERE status = 'black'
                    ORDER BY time DESC 
                    LIMIT ".$begin.", ".$all_number_links."";
			
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	if($result->num_rows > 0 ){
		while($row = $result->fetch_array())
		{		
			$rowBlock = $tpl->fetch('row');				
			$rowBlock->assign('DESCRIPTION', $row['description']);				
			$rowBlock->assign('NAME', $row['name']);
			$rowBlock->assign('URL', $row['url']);
			$rowBlock->assign('EMAIL', $row['email']);
			$rowBlock->assign('CATEGORY', $row['catname']);
			$rowBlock->assign('REASON', $row['reason']);
			$rowBlock->assign('TIME', $row['time']);
			$rowBlock->assign('ID_LINK', $row['id_link']);
			$rowBlock->assign('PHP_SELF', $_SERVER['PHP_SELF']);	
			$rowBlock->assign('STR_EMAIL', STR_EMAIL);
			$rowBlock->assign('STR_CATEGORY', STR_CATEGORY);
			$rowBlock->assign('STR_REASON', STR_REASON);		
			$rowBlock->assign('STR_BLACKLISTED', STR_BLACKLISTED);				
			$rowBlock->assign('BUTTON_DELETE', BUTTON_DELETE);
			$rowBlock->assign('BUTTON_RESTORE', BUTTON_RESTORE);
				
			$tpl->assign('row', $rowBlock);		
		}
		
		// Count a quantity of the links
		$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'black'";
		$result = $dbh->query($query);
			
		if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
			
		$total = $result->fetch_assoc();

		// Clear the descriptor
		$result->close();

		$number = intval(($total['COUNT(*)'] - 1) / $all_number_links) + 1;
			
		if($page != 1) {
			$pervpage = '<a href="'.$_SERVER['PHP_SELF'].'?page=1">&lt;&lt;</a>';
			$perv = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 1).'">&lt;</a>'; 
		}

		if($page != $number) {
			$nextpage = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 1).'">&gt;</a>'; 
			$next = '<a href="'.$_SERVER['PHP_SELF'].'?page='.$number.'">&gt;&gt;</a>';
		}									

		if($page - 2 > 0) $page2left = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 2).'">...'.($page - 2).'</a>';
		if($page - 1 > 0) $page1left = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 1).'">'.($page - 1).'</a>';
		if($page + 2 <= $number) $page2right = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 2).'">'.($page + 2).'...</a>';
		if($page + 1 <= $number) $page1right = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 1).'">'.($page + 1).'</a>';
			
		if($number > 1){
			$paginationBlock = $tpl->fetch('pagination');	
			$paginationBlock->assign('CURRENT_PAGE','<a>'.$page.'</a>');
			$paginationBlock->assign('STR_PAGES', STR_PAGES);
			$paginationBlock->assign('PAGE1RIGHT', $page1right);
			$paginationBlock->assign('PAGE2RIGHT', $page2right);

			$paginationBlock->assign('PAGE1LEFT', $page1left);
			$paginationBlock->assign('PAGE2LEFT', $page2left);

			$paginationBlock->assign('PERVPAGE', $pervpage);
			$paginationBlock->assign('NEXTPAGE', $nextpage);
	
			$paginationBlock->assign('PERV', $perv);
			$paginationBlock->assign('NEXT', $next);
			
			$tpl->assign('pagination', $paginationBlock);			
		}
	}
	else{
		$tpl->assign('MSG_NOTLINKS',MSG_NOTLINKS);
	}		

	//footer
	include "footer.inc";
		
	// Count a quantity of the links
	$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
		
	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
		
	$total = $result->fetch_assoc();

	// Clear the descriptor
	$result->close();
		
	$tpl->assign("TOTAL_LINKS",$total['COUNT(*)']);
	$tpl->assign("STR_HELP", STR_HELP);
		
	// print html page
	$tpl->display();	

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>