<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

ob_start();

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";
		
	$_GET['id_cat'] = $dbh->real_escape_string($_GET['id_cat']);
	$_POST['id_link'] = $dbh->real_escape_string($_POST['id_link']);	
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();	
	
	$all_number_links = $settings['all_number_links'] ? $settings['all_number_links'] : 5;	
	
	$page = $_GET['page'];

	if(empty($page)) $page = 1;
	$begin = ($page - 1) * $all_number_links;	
	
	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";	

	// Authenticate
	require "../lib/authenticate.inc";

	// template
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/check_links.tpl");
	
	//header
	include "header.inc";
			
	// menu
	include "menu.inc";	

	if(!empty($_POST['action'])){
		switch ($_POST['event'])
		{
			// Add link
			case add:
				$update = "UPDATE ".DB_LINKS." SET status = 'show' WHERE id_link = ".$_POST['id_link'];

				if($dbh->query($update)){
					$query = "SELECT * FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];
					$result = $dbh->query($query);

					if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

					$links = $result->fetch_array();

					$result->close();

					// Notify the user about his link was added
					sendMailAdd($links, STR_SUBJECT_ADD);

					$success = MSG_LINK_ADDED;
					$_POST['action'] = '';
				}
				else { throw new ExceptionMySQL($dbh->error,$update,"Error executing SQL query!"); }

			break;
		
			// Remove link
			case delete:
				
				$delete = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];

				if($dbh->query($delete)){
					$success = MSG_LINK_REMOVED;
					$_POST['action'] = '';
				}
				else { throw new ExceptionMySQL($dbh->error,$delete,"Error executing SQL query!"); }

			break;		
		
			// Add link to black list
			case black:
				$update = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_ADMIN."' WHERE id_link = ".$_POST['id_link'];

				if($dbh->query($update)){
					$success = MSG_LINK_ADDED_TO_BLACKLIST;	
					$_POST['action'] = '';
				}
				else { throw new ExceptionMySQL($dbh->error, $update, "Error executing SQL query!"); }


			break;
		
			case check_hand:
			
				$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_CHECK_LINKS);
				$tpl->assign('TITLE', TITLEADMIN_CHECK_LINKS);		
			
				$query = "SELECT *, c.name AS catname, l.description AS description, l.name AS name FROM ".DB_LINKS." l LEFT JOIN ".DB_CATALOG." c ON l.id_cat = c.id_cat WHERE id_link = ".$_POST['id_link'];
				$result = $dbh->query($query);

				if(!$result) { throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); }

				$links = $result->fetch_array();

				$result->close();				
		
				if(!empty($links['htmlcode_banner'])) 
					$htmlcode_banner = $links['htmlcode_banner'];
				else 
					$htmlcode_banner = '<a href="http://'.$links['url'].'"><img border="0" width="88" height="31" src="./images/noimage.gif"></a>';

				$links['description'] = nl2br($links['description']);
				
				$blockCheckLink = $tpl->fetch('CHECK_LINK');				
				$blockCheckLink->assign("RETURN_BACK", STR_GO_BACK);				
				$blockCheckLink->assign("STR_RECIPROCAL_LINK", STR_RECIPROCAL_LINK);				
				$blockCheckLink->assign("STR_CATEGORY", STR_CATEGORY);		
				$blockCheckLink->assign("STR_ADDED", STR_ADDED);				
				$blockCheckLink->assign("HTMLCODE_BANNER", $htmlcode_banner);			
				$blockCheckLink->assign("NAME", $links['name']);				
				$blockCheckLink->assign("URL", $links['url']);				
				$blockCheckLink->assign("CATNAME", $links['catname']);				
				$blockCheckLink->assign("TIME", $links['time']);				
				$blockCheckLink->assign("ACTION", $_SERVER['PHP_SELF']);				
				$blockCheckLink->assign("ID_LINK", $links['id_link']);				
				$blockCheckLink->assign("DESCRIPTION", $links['description']);				
				$blockCheckLink->assign("RECIPROCAL_LINK", $links['reciprocal_link']);				
				$blockCheckLink->assign('SHOW_PR', $settings['show_pr']);
				$blockCheckLink->assign('SHOW_CY', $settings['show_cy']);				
				$blockCheckLink->assign('BUTTON_ADD', BUTTON_ADD);
				$blockCheckLink->assign('BUTTON_DELETE', BUTTON_DELETE);
				$blockCheckLink->assign('BUTTON_TO_BLACKLIST', BUTTON_TO_BLACKLIST);

				$tpl->assign('CHECK_LINK', $blockCheckLink);
	
			break;	

			case check_aut:
		
				$query = "SELECT * FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];
				$result = $dbh->query($query);

				if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

				$links = $result->fetch_array();

				$result->close();

				if(check_url_link ($links['reciprocal_link'], $settings['url'])){
					if($links['status'] == "hide"){
						if($settings['add_to_blacklist'] == "yes"){
							$query = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_ABSENSE_RECIPROCAL."' WHERE id_link = ".$links['id_link'];
						}
						else{
							$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$links['id_link'];
						}

						if($dbh->query($query)){
							// Notify the user about his link was removed
							sendmail_del_link($links, STR_SUBJECT_DEL);
							
							$success = MSG_CHECK_IS_COMPLETED;
							$_POST['action'] = '';

						} else { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
					}
					else{
						$query = "UPDATE ".DB_LINKS." SET status = 'hide', time_check = NOW(), reason = '".REASON_ABSENSE_RECIPROCAL."' WHERE id_link = ".$links['id_link'];

						if($dbh->query($query)){
							// Notify the user about his link was hidded
							$nscript = strpos($_SERVER['REQUEST_URI'], "admin");
							$root = substr($_SERVER['REQUEST_URI'], 0, $nscript);
							$url_link_edit = "".$_SERVER['SERVER_NAME'].$root."edit.php?id=".$links['id_link']."&token=".$links['token']."";

							sendmail_hide_link ($links, $url_link_edit, STR_SUBJECT_HIDE);

							$success = MSG_CHECK_IS_COMPLETED;
							$_POST['action'] = '';

						} else { throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); }
					}
				}
				else{
					// Check on, whether the page of answer link is closed for index
					if(check_meta($links['reciprocal_link'])){
						if($links['status'] == "hide"){
							if($settings['add_to_blacklist'] == "yes"){
								$query = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_META."' WHERE id_link = ".$links['id_link'];
							}
							else{
								$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$links['id_link'];
							}

							if($dbh->query($query)){
								// Notify the user about his link was removed
								sendmail_del_link($links, STR_SUBJECT_DEL);
								
								$success = MSG_CHECK_IS_COMPLETED;
								$_POST['action'] = '';

							} else { throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); }
						}
						else{
							$query = "UPDATE ".DB_LINKS." SET status = 'hide',time_check = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_META."' WHERE id_link = ".$links['id_link'];

							if($dbh->query($query)){
								// Notify the user about his link was hidded
								sendmail_hide_link2($links, MSG_CLOSED_FOR_INDEX_META, STR_SUBJECT_HIDE);

								$success = MSG_CHECK_IS_COMPLETED;
								$_POST['action'] = '';

							} else { throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); }
						}
					}
					else{
						// Check on, whether the directory is closed for index
						if(check_robots($links['reciprocal_link'])){
							if($links['status'] == "hide"){
								if($settings['add_to_blacklist'] == "yes"){
									$query = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_ROBOT."' WHERE id_link = ".$links['id_link'];
								}
								else{
									$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$links['id_link'];
								}

								if($dbh->query($query)){
									// Notify the user about his link was removed
									sendmail_del_link($links, STR_SUBJECT_DEL);

									$success = MSG_CHECK_IS_COMPLETED;
									$_POST['action'] = '';

								} else { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
							}
							else{
								$query = "UPDATE ".DB_LINKS." SET status = 'hide', time_check = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_ROBOT."' WHERE id_link = ".$links['id_link'];

								if($dbh->query($query))	{
									// Notify the user about his link was hidded
									sendmail_hide_link2($links, MSG_CLOSED_FOR_INDEX_ROBOT, STR_SUBJECT_HIDE);

									$success = MSG_CHECK_IS_COMPLETED;
									$_POST['action'] = '';

								} else { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
							}
						}
						else{
							if($links['status'] == "hide"){
								$query = "UPDATE ".DB_LINKS." SET status = 'show', time_check = NOW(), reason = '', number_check = 0 WHERE id_link = ".$links['id_link'];

								if($dbh->query($query)){
									// Notify the user about his link was restored
									sendMailAdd($links, STR_SUBJECT_ADD);

									$success = MSG_CHECK_IS_COMPLETED;
									$_POST['action'] = '';

								} else { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
							}

							if($links['status'] == "show"){
								$query = "UPDATE ".DB_LINKS." SET time_check = NOW(), number_check = 0 WHERE id_link = ".$links['id_link'];

								if($dbh->query($query)){
									$success = MSG_CHECK_IS_COMPLETED;
									$_POST['action'] = '';
								} else { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
							}
						}
					}
				}
		
			break;	
		
			case check_all_aut:
		
				$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_CHECK_LINKS);
				$tpl->assign('TITLE', TITLEADMIN_CHECK_LINKS);			

				$tpl->assign('HELP', INFO_CHECK_CHECK_LINKS);

				$add = 0;
				$del = 0;
				$hide = 0;

				// Check all hidded link
				$query = "SELECT * FROM ".DB_LINKS." WHERE status = 'hide'";
				$result = $dbh->query($query);

				if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
				
				while($links = $result->fetch_array())
				{
					$date_check = strtotime($links['time_check']);
					$interval_check = ceil((time() - $date_check) / 3600 / 24);
	
					if($links['check_link'] == "yes" AND $interval_check > $settings['check_interval'] AND $interval_check != 1){
						if(check_url_link ($links['reciprocal_link'], $settings['url'])){
							if($settings['add_to_blacklist'] == "yes"){
								$query = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_ABSENSE_RECIPROCAL."' WHERE id_link = ".$links['id_link'];
							}
							else{
								$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$links['id_link'];
							}

							if($dbh->query($query)){
								// Notify the user about his link was removed
								sendmail_del_link($links, STR_SUBJECT_DEL);

								// Count a quantity of the links which was removed
								$del = $del + 1;
							}
						}
						else{
						
							// Check on, whether the page of answer link for index by metatag <meta name=robot>
							if(check_meta($links['reciprocal_link'])){
								if($settings['add_to_blacklist'] == "yes"){
									$query = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_META."' WHERE id_link = ".$links['id_link'];
								}
								else{
									$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$links['id_link'];
								}

								if($dbh->query($query)){
									// Notify the user about his link was removed
									sendmail_del_link($links, STR_SUBJECT_DEL);

									// Count a quantity of the links which was removed
									$del = $del + 1;
								}
							}
							else{
								// Check on, whether the directory with answer link is closed for index
								if(check_robots($links['reciprocal_link'])){
									if($settings['add_to_blacklist'] == "yes"){
										$query = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_ROBOT."' WHERE id_link = ".$links['id_link'];
									}
									else{
										$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$links['id_link'];
									}

									if($dbh->query($query)){
										// Notify the user about his link was removed
										sendmail_del_link($links, STR_SUBJECT_DEL);

										// Count a quantity of the links which was removed
										$del = $del + 1;
									}
								}
								else{
									$update = "UPDATE ".DB_LINKS." SET status = 'show', time_check = NOW(), reason = '', number_check = 0 WHERE id_link = ".$links['id_link'];

									if($dbh->query($update)){
										// Notify the user about his link was restored
										sendMailAdd($links, STR_SUBJECT_ADD);

										// Count a quantity of the links which was added
										$add = $add + 1;
									}
								}
							}
						}							
					}
			
					$result->close();					
				}	
				
				// Check all other links
				$query = "SELECT * FROM ".DB_LINKS." WHERE status = 'show'";
				$result = $dbh->query($query);
					
				if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
	
				while($links = $result->fetch_array()){
					$date_check = strtotime($links['time_check']);
					$interval_check = ceil((time() - $date_check) / 3600 / 24);
					
					if($links['check_link'] == "yes" AND $interval_check > $settings['check_interval'] AND $interval_check != 1){
						if(check_url_link ($links['reciprocal_link'],$settings['url'])){
							if($links['number_check'] == $settings['number_check']){
								// Form SQL-query to hide link
								$update = "UPDATE ".DB_LINKS." SET status = 'hide', time_check = NOW(), reason = '".REASON_ABSENSE_RECIPROCAL."' WHERE id_link = ".$links['id_link'];

								if($dbh->query($update)){
									// Notify the user about his link was hidded
									$nscript = strpos($_SERVER['REQUEST_URI'], "admin");
									$root = substr($_SERVER['REQUEST_URI'], 0, $nscript);
									$url_link_edit = "".$_SERVER['SERVER_NAME'].$root."edit.php?id=".$links['id_link']."&token=".$links['token']."";

									sendmail_hide_link ($links, $url_link_edit, STR_SUBJECT_HIDE);

									// Count a quantity of the links which was hidded
									$hide = $hide + 1;
								}
							}
							else{
								$update = "UPDATE ".DB_LINKS." SET time_check = NOW(), number_check = number_check + 1 WHERE id_link = ".$links['id_link'];
								$dbh->query($update);										
							}							
						}
						else{
							// Check the page of answer link on index
							if(check_meta($links['reciprocal_link'])){
								if($links['number_check'] == $settings['number_check']){
									// Form SQL-query to hide link
									$update = "UPDATE ".DB_LINKS." SET status = 'hide', time_check = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_ROBOT."' WHERE id_link = ".$links['id_link'];

									if($dbh->query($update)){
										// Notify the user about the link was hidded
	
										sendmail_hide_link2($links, MSG_CLOSED_FOR_INDEX_ROBOT, STR_SUBJECT_HIDE);

										// Count a quantity of the links which was hidded
										$hide = $hide + 1;
									}
								}
								else{
									$update = "UPDATE ".DB_LINKS." SET time_check = NOW(), number_check = number_check + 1 WHERE id_link = ".$links['id_link'];
									$dbh->query($update);									
								}
							}
							else{
								// Check the directory is closed for index
								if(check_robots($links['reciprocal_link']))	{
									if($links['number_check'] == $settings['number_check']){
										// Form SQL-query to hide link
										$update = "UPDATE ".DB_LINKS." SET status = 'hide', time_check = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_ROBOT."' WHERE id_link = ".$links['id_link'];

										if($dbh->query($update)){
											// Notify the user about his link was hidded
											$reason = MSG_CLOSED_FOR_INDEX_ROBOT;

											sendmail_hide_link2($links, $reason, STR_SUBJECT_HIDE);

											// Count a quantity of the links which was hidded
											$hide = $hide + 1;
										}
									}else{
										$update = "UPDATE ".DB_LINKS." SET time_check = NOW(), number_check = number_check + 1 WHERE id_link = ".$links['id_link'];
										$dbh->query($update);
									}
								}
								else{
									$update = "UPDATE ".DB_LINKS." SET time_check = NOW(), reason = '', number_check = 0 WHERE id_link = ".$links['id_link'];
									$dbh->query($update);
								}
							}
						}
					}
				}				
			
				$result->close();
				
				//alert
				if(!empty($success)){ 
					$tpl->assign('MSG_ALERT', MSG_CHECK_IS_COMPLETED);
				}	
			
				$blockStatistics = $tpl->fetch('STATISTICS');
				$blockStatistics->assign('STR_GO_BACK', STR_GO_BACK);
				$blockStatistics->assign('STR_REMOVED_LINKS', STR_RESULT_REMOVED_LINKS);
				$blockStatistics->assign('STR_RESULT_HIDDED_LINKS', STR_RESULT_HIDDED_LINKS);
				$blockStatistics->assign('STR_RESULT_ADDED_LINKS', STR_RESULT_ADDED_LINKS);
				$blockStatistics->assign('HIDE', $hide);
				$blockStatistics->assign('ADD', $add);
				$blockStatistics->assign('DEL', $del);
				$tpl->assign('STATISTICS', $blockStatistics);			

			break;		
	
		}
	}

	if(empty($_POST['action'])) {
		//alert
		if(!empty($success)){ 
			$tpl->assign('MSG_ALERT', MSG_CHECK_IS_COMPLETED);
		}	
	
		$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_CHECK_LINKS);
		$tpl->assign('TITLE', TITLEADMIN_CHECK_LINKS);	
		$tpl->assign('HELP', INFO_CHECK_CHECK_LINKS);

		$blockLinksList = $tpl->fetch('LINKS_LIST');
		$blockLinksList->assign('ACTION', $_SERVER['PHP_SELF']);
		$blockLinksList->assign('BUTTON_CHECK_ALL_LINKS_AUTOMATICALLY', BUTTON_CHECK_ALL_LINKS_AUTOMATICALLY);

		$id_cat	= $_GET['id_cat'] ? $_GET['id_cat'] : 0;

		$query = "SELECT * FROM ".DB_CATALOG." WHERE id_parent=".$id_cat." ORDER BY name";
		$result = $dbh->query($query);

		if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

		while($row = $result->fetch_array())
		{
			$arraycat[] = array($row['name'], $row['id_cat']); 
		}

		$result->close();

		$total = count($arraycat);

		$number = (int)($total / $settings['columns_number']);
		if((float)($total / $settings['columns_number']) - $number != 0) $number++;

		
		$rowPrintCat = $blockLinksList->fetch('PRINT_CAT');
		
		// Form an array
		for($i = 0; $i < $number; $i++){
			for($j = 0; $j < $settings['columns_number']; $j++){
				$arr[$i][$j] = $arraycat[$j * $number + $i];
			}
		}		

		for($i = 0; $i < $number; $i++){
			$rowBlockCat = $rowPrintCat->fetch('ROW_CAT');

			for($j = 0; $j < $settings['columns_number']; $j++){
			
				$rowBlockFolder = $rowBlockCat->fetch('ROW_FOLDER');
			
				if($arr[$i][$j][0]){
					$rowBlockFolder->assign('FOLDER_LINK', "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']."?id_cat=".$arr[$i][$j][1]);
					
					$columns_number = (int)(100 / $settings['columns_number']);
					$rowBlockFolder->assign('COLUMNS_NUMBER', $columns_number);	
					$rowBlockFolder->assign('FOLDER_LINK_NAME', $arr[$i][$j][0]);
					$rowBlockFolder->assign('NUMBERSLINKS', ShowNumbersLinks($arr[$i][$j][1],0));
					$rowBlockFolder->assign('SHOWSUBCAT', ShowSubCat($arr[$i][$j][1],0,0));
				}
				
				$rowBlockCat->assign('ROW_FOLDER', $rowBlockFolder);
			}

			$rowPrintCat->assign('ROW_CAT', $rowBlockCat);
		}
		
		$blockLinksList->assign('PRINT_CAT', $rowPrintCat);		
	
		if($_GET['id_cat']){
			$arraypathway = Array();
			$arraypathway = topbarmenu($_GET['id_cat'], '');	
			$pathway = '<a href="check_links.php">'.STR_HOME.'</a> ';	

			for($i = 0; $i < count($arraypathway); $i++){
				$pathway .= '» <a href="http://'.$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'].'?id_cat='.$arraypathway[$i][0].'">'.$arraypathway[$i][1].'</a>';
			}	

			$blockLinksList->assign('TOPBARMENU', $pathway);
		}
		
		if($_GET['id_cat']){
			$query = "SELECT name FROM ".DB_CATALOG." WHERE id_cat = ".$_GET['id_cat'];
			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); }

			$catname = $result->fetch_array();
		
			$result->close();				
		
			$blockLinksList->assign('ID_CAT', $_GET['id_cat']);
			$blockLinksList->assign('CATEGORY_NAME', $catname['name']);
			$blockLinksList->assign('RETURN_URL', 'check_links.php');
			$blockLinksList->assign('STR_LINKS_WAITING_CHECKS', STR_LINKS_WAITING_CHECKS);
			
			$query = "SELECT *, c.name AS catname, l.name AS name, l.description AS description FROM ".DB_LINKS." l LEFT JOIN ".DB_CATALOG." c ON l.id_cat=c.id_cat WHERE l.id_cat = ".$_GET['id_cat']." AND status = 'show' ORDER BY time DESC LIMIT ".$begin.", ".$all_number_links."";
			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); }
				
			if($result->num_rows>0){	
				while($row = $result->fetch_array()){	
					$date_check = strtotime($row['time_check']);
					$interval_check = ceil((time() - $date_check) / 3600 / 24);
		
					if(!empty($row['htmlcode_banner']))
						$htmlcode_banner = $row['htmlcode_banner'];
					else 
						$htmlcode_banner = '<a href="http://'.$row['url'].'" target=_blank><img border="0" width="88" height="31" src="./images/noimage.gif"></a>';
						
					$rowBlock = $blockLinksList->fetch('ROW_LINKS');
					$rowBlock->assign('HTMLCODE_BANNER', $htmlcode_banner);
					$rowBlock->assign('URL', $row['url']);
					$rowBlock->assign('NAME', $row['name']);
					$rowBlock->assign('DESCRIPTION', $row['description']);
					$rowBlock->assign('STR_ADDED', STR_ADDED);
					$rowBlock->assign('TIME', $row['time']);
					$rowBlock->assign('ID_LINK', $row['id_link']);
					$rowBlock->assign('STR_NUMBER_OF_CLICKS', STR_NUMBER_OF_CLICKS);
					$rowBlock->assign('COUNT', $row['count']);
				
					$rowBlock->assign('SHOW_PR', $settings['show_pr']);
					$rowBlock->assign('SHOW_CY', $settings['show_cy']);					
			
					if($row['check_link'] == "yes" OR !empty($row['reciprocal_link'])){	
					
						$BUTTON1 = $rowBlock->fetch('BUTTON1');
						$BUTTON1->assign('ACTION1', $_SERVER['PHP_SELF']);
						$BUTTON1->assign('STR_BUTTON1', BUTTON_HANDCHECK);							
						$BUTTON1->assign('ID_LINK1', $row['id_link']);	
						$rowBlock->assign('BUTTON1', $BUTTON1);
					}						
							
					if(!empty($row['reciprocal_link'])) {
						$BUTTON2 = $rowBlock->fetch('BUTTON2');
						$BUTTON2->assign('ACTION2', $_SERVER['PHP_SELF']);
						$BUTTON2->assign('ID_LINK2', $row['id_link']);
						$BUTTON2->assign('STR_BUTTON2', BUTTON_AUTOCHECK);
						$BUTTON2->assign('INTERVAL_CHECK', $interval_check);
						$rowBlock->assign('BUTTON2', $BUTTON2);	
					}			
							
					$blockLinksList->assign('ROW_LINKS', $rowBlock);	
				}	

			} else $blockLinksList->assign('MSG_NOTLINKS', MSG_NOTLINKS);			
		
			// Count a quantity of the links
			$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE id_cat = ".$_GET['id_cat']." AND status = 'show'";
			$result = $dbh->query($query);
			
			if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
			
			$total = $result->fetch_assoc();

			// Clear the descriptor
			$result->close();

			$number = intval(($total['COUNT(*)'] - 1) / $all_number_links) + 1;			
			
			if($page != 1) {
				$pervpage = '<a href="'.$_SERVER['PHP_SELF'].'?page=1'.($_GET['id_cat'] ? '&id_cat='.$_GET['id_cat'].'' : '').'">&lt;&lt;</a>';
				$perv = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 1).''.($_GET['id_cat'] ? '&id_cat='.$_GET['id_cat'].'' : '').'">&lt;</a>'; 
			}

			if($page != $number) {
				$nextpage = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 1).''.($_GET['id_cat'] ? '&id_cat='.$_GET['id_cat'].'' : '').'">&gt;</a>'; 
				$next = '<a href="'.$_SERVER['PHP_SELF'].'?page='.$number.''.($_GET['id_cat'] ? '&id_cat='.$_GET['id_cat'].'' : '').'">&gt;&gt;</a>';
			}									

			if($page - 2 > 0) $page2left = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 2).''.($_GET['id_cat'] ? '&id_cat='.$_GET['id_cat'].'' : '').'">...'.($page - 2).'</a>';
			if($page - 1 > 0) $page1left = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 1).''.($_GET['id_cat'] ? '&id_cat='.$_GET['id_cat'].'' : '').'">'.($page - 1).'</a>';
			if($page + 2 <= $number) $page2right = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 2).''.($_GET['id_cat'] ? '&id_cat='.$_GET['id_cat'].'' : '').'">'.($page + 2).'...</a>';
			if($page + 1 <= $number) $page1right = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 1).''.($_GET['id_cat'] ? '&id_cat='.$_GET['id_cat'].'' : '').'">'.($page + 1).'</a>';
			
			if($number > 1){
				$paginationBlock = $blockLinksList->fetch('pagination');	
				$paginationBlock->assign('CURRENT_PAGE','<a>'.$page.'</a>');
				$paginationBlock->assign('STR_PAGES', STR_PAGES);
				$paginationBlock->assign('PAGE1RIGHT', $page1right);
				$paginationBlock->assign('PAGE2RIGHT', $page2right);

				$paginationBlock->assign('PAGE1LEFT', $page1left);
				$paginationBlock->assign('PAGE2LEFT', $page2left);

				$paginationBlock->assign('PERVPAGE', $pervpage);
				$paginationBlock->assign('NEXTPAGE', $nextpage);
	
				$paginationBlock->assign('PERV', $perv);
				$paginationBlock->assign('NEXT', $next);
			
				$blockLinksList->assign('pagination', $paginationBlock);			
			}
		}
		else{
			$blockLinksList->assign('STR_LINKS_FOR_CHECK', STR_LINKS_FOR_CHECK);
	
			$query = "SELECT * FROM ".DB_LINKS." WHERE status = 'hide' ORDER BY time DESC";
			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

			if($result->num_rows > 0){
				while($row = $result->fetch_array()){
					if(!empty($row['htmlcode_banner']))
						$htmlcode_banner = $row['htmlcode_banner'];
					else 
						$htmlcode_banner = '<a href="http://'.$row['url'].'" target=_blank><img border="0" width="88" height="31" src="./images/noimage.gif"></a>';
					
					$date_check = strtotime($row['time_check']);
					$interval_check = ceil((time() - $date_check) / 3600 / 24);		
					
					$rowBlock = $blockLinksList->fetch('ROW_LINKS');
					$rowBlock->assign('MSG_ALERT_WAS_CHECKED', MSG_ALERT_WAS_CHECKED);					
					
					$rowBlock->assign('HTMLCODE_BANNER', $htmlcode_banner);
					$rowBlock->assign('URL', $row['url']);
					$rowBlock->assign('NAME', $row['name']);
					$rowBlock->assign('DESCRIPTION', $row['description']);
					$rowBlock->assign('STR_ADDED', STR_ADDED);
					$rowBlock->assign('TIME', $row['time']);
					$rowBlock->assign('ID_LINK', $row['id_link']);
					$rowBlock->assign('STR_NUMBER_OF_CLICKS', STR_NUMBER_OF_CLICKS);
					$rowBlock->assign('COUNT', $row['count']);				
					$rowBlock->assign('SHOW_PR', $settings['show_pr']);
					$rowBlock->assign('SHOW_CY', $settings['show_cy']);				
							
					if($row['check_link'] == "yes" OR !empty($row['reciprocal_link'])){	
						$BUTTON1 = $rowBlock->fetch('BUTTON1');
						$BUTTON1->assign('ACTION1', $_SERVER['PHP_SELF']);
						$BUTTON1->assign('STR_BUTTON1', BUTTON_HANDCHECK);							
						$BUTTON1->assign('ID_LINK1', $row['id_link']);	
						$rowBlock->assign('BUTTON1', $BUTTON1);
					}						
							
					if(!empty($row['reciprocal_link'])) {
						$BUTTON2 = $rowBlock->fetch('BUTTON2');
						$BUTTON2->assign('ACTION2', $_SERVER['PHP_SELF']);
						$BUTTON2->assign('ID_LINK2', $row['id_link']);					
						$BUTTON2->assign('MSG_ALERT_WAS_CHECKED', MSG_ALERT_WAS_CHECKED);
						
						if($interval_check == 1) $BUTTON2->assign('ALERT','show');
						
						$BUTTON2->assign('STR_BUTTON2', BUTTON_AUTOCHECK);
						$BUTTON2->assign('INTERVAL_CHECK', $interval_check);
						$rowBlock->assign('BUTTON2', $BUTTON2);	
					}	
							
					$blockLinksList->assign('ROW_LINKS', $rowBlock);	
				}
			
			}else $blockLinksList->assign('MSG_NOTLINKS', MSG_NOTLINKS);
			
			$result->close();
		}	
		
		// Count a quantity of the links
		$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'hide'";
		$result = $dbh->query($query);
			
		if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
			
		$total = $result->fetch_assoc();

		// Clear the descriptor
		$result->close();

		$number = intval(($total['COUNT(*)'] - 1) / $all_number_links) + 1;		
		
		if($page != 1) {
			$pervpage = '<a href="'.$_SERVER['PHP_SELF'].'?page=1">&lt;&lt;</a>';
			$perv = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 1).'">&lt;</a>'; 
		}

		if($page != $number) {
			$nextpage = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 1).'">&gt;</a>'; 
			$next = '<a href="'.$_SERVER['PHP_SELF'].'?page='.$number.'">&gt;&gt;</a>';
		}									

		if($page - 2 > 0) $page2left = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 2).'">...'.($page - 2).'</a>';
		if($page - 1 > 0) $page1left = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 1).'">'.($page - 1).'</a>';
		if($page + 2 <= $number) $page2right = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 2).'">'.($page + 2).'...</a>';
		if($page + 1 <= $number) $page1right = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 1).'">'.($page + 1).'</a>';
			
		if($number > 1){
			$paginationBlock = $blockLinksList->fetch('pagination');	
			$paginationBlock->assign('CURRENT_PAGE','<a>'.$page.'</a>');
			$paginationBlock->assign('STR_PAGES', STR_PAGES);
			$paginationBlock->assign('PAGE1RIGHT', $page1right);
			$paginationBlock->assign('PAGE2RIGHT', $page2right);

			$paginationBlock->assign('PAGE1LEFT', $page1left);
			$paginationBlock->assign('PAGE2LEFT', $page2left);

			$paginationBlock->assign('PERVPAGE', $pervpage);
			$paginationBlock->assign('NEXTPAGE', $nextpage);
	
			$paginationBlock->assign('PERV', $perv);
			$paginationBlock->assign('NEXT', $next);
			
			$blockLinksList->assign('pagination', $paginationBlock);			
		}	
	
		$tpl->assign('LINKS_LIST', $blockLinksList);	
	}

	//footer
	include "footer.inc";
		
	// Count a quantity of the links
	$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
		
	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
		
	$total = $result->fetch_assoc();

	// Clear the descriptor
	$result->close();
		
	$tpl->assign("TOTAL_LINKS", $total['COUNT(*)']);	
	$tpl->assign("STR_HELP", STR_HELP);

	// print html page
	$tpl->display();	

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>