<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

ob_start();

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();	
	
	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";	

	// Authenticate
	require "../lib/authenticate.inc";

	if(!empty($_POST["action"])){
		switch ($_POST["action"])
		{
			case style:

				$_POST['style'] = stripslashes($_POST['style']);
				$_POST['style'] = preg_replace('/<\?(php)?/i', '', $_POST['style']);
				$_POST['style'] = preg_replace('/\?>/i', '', $_POST['style']);

				// Add changes in file style.css
				if($fd = fopen("../style/style.css","w")){
					fputs($fd, $_POST['style']);
					fclose($fd);
					
					$success = MSG_CHANGES_ADDED;
				}
				else{
					$error = preg_replace('%FILE%','style.css',MSG_ERROR_FAILED_ADD_CHANGES_DESIGN);
				}

			break;

			case header:
			
				$_POST['header'] = stripslashes($_POST['header']);
				$_POST['header'] = preg_replace('/<\?(php)?/i', '', $_POST['header']);
				$_POST['header'] = preg_replace('/\?>/i', '', $_POST['header']);
				$_POST['header'] = preg_replace("|\[(\w+)\]|sU", "\${\\1}", $_POST['header']);

				// Add the changes in file header.tpl
				if($fd = fopen("../templates/header.tpl","w")){
				
					fputs($fd, $_POST['header']);
					fclose($fd);
					
					$success = MSG_CHANGES_ADDED;
				}
				else{
					$error = preg_replace('%FILE%','header.tpl',MSG_ERROR_FAILED_ADD_CHANGES_DESIGN);
				}

			break;

			case index:
				$_POST['links'] = stripslashes($_POST['links']);
				$_POST['links'] = preg_replace('/<\?(php)?/i', '', $_POST['links']);
				$_POST['links'] = preg_replace('/\?>/i', '', $_POST['links']);
				$_POST['links'] = preg_replace("|\[(\w+)\]|sU", "\${\\1}", $_POST['links']);

				// Add changes in file index.tpl
				if($fd = fopen("../templates/index.tpl","w")){
					fputs($fd, $_POST['links']);
					fclose($fd);
					
					$success = MSG_CHANGES_ADDED;				
				}
				else{
					$error = preg_replace('%FILE%','index.tpl', MSG_ERROR_FAILED_ADD_CHANGES_DESIGN);
				}

			break;

			case add_url:

				$_POST['add_url'] = stripslashes($_POST['add_url']);
				$_POST['add_url'] = preg_replace('/<\?(php)?/i', '', $_POST['add_url']);
				$_POST['add_url'] = preg_replace('/\?>/i', '', $_POST['add_url']);
				$_POST['add_url'] = preg_replace("|\[(\w+)\]|sU", "\${\\1}", $_POST['add_url']);

				// Add changes in file link.html
				if($fd = fopen("../templates/add_url.tpl","w")){				
					fputs($fd, $_POST['add_url']);
					fclose($fd);
				
					$success = MSG_CHANGES_ADDED;
				}
				else{
					$error = preg_replace('%FILE%','add_url.tpl',MSG_ERROR_FAILED_ADD_CHANGES_DESIGN);
				}

			break;

			case footer:

				$_POST['footer'] = stripslashes($_POST['footer']);
				$_POST['footer'] = preg_replace('/<\?(php)?/i', '', $_POST['footer']);
				$_POST['footer'] = preg_replace('/\?>/i', '', $_POST['footer']);
				$_POST['footer'] = preg_replace("|\[(\w+)\]|sU", "\${\\1}", $_POST['footer']);

				// Add changes in file footer.html
				if($fd = fopen("../templates/footer.tpl","w")){
					fputs($fd, $_POST['footer']);
					fclose($fd);

					$success = MSG_CHANGES_ADDED;	
				}
				else{
					$error = preg_replace('%FILE%', 'footer.tpl', MSG_ERROR_FAILED_ADD_CHANGES_DESIGN);
				}

			break;

			default:
			
				header("Location: design.php");
				exit;
				
			break;
		}
	}	
	
	// Read the contents of file of style.css in the buffer
	$fd = @fopen("../style/style.css", "r");
	$bufer1 = @fread($fd, filesize("../style/style.css"));
	fclose($fd);

	// Read the contents of file of top.html in the buffer
	$fd = @fopen("../templates/header.tpl", "r");
	$bufer2 = @fread($fd, filesize("../templates/header.tpl"));
	fclose($fd);

	$bufer2 = preg_replace('/\${(\w+)}/sU', "[\\1]", $bufer2);

	// Read the contents of file of bottom.html in the buffer
	$fd = @fopen("../templates/footer.tpl", "r");
	$bufer3 = @fread($fd, filesize("../templates/footer.tpl"));
	fclose($fd);

	$bufer3 = preg_replace('/\${(\w+)}/sU', "[\\1]", $bufer3);

	// Read the contents of file of index.tpl in the buffer
	$fd = @fopen("../templates/index.tpl", "r");
	$bufer4 = @fread($fd, filesize("../templates/index.tpl"));
	fclose($fd);

	$bufer4 = preg_replace('/\${(\w+)}/sU', "[\\1]", $bufer4);

	// Read the contents of file of add_url.tpl in the buffer
	$fd = @fopen("../templates/add_url.tpl", "r");
	$bufer5 = @fread($fd, filesize("../templates/add_url.tpl"));
	fclose($fd);

	$bufer5 = preg_replace('/\${(\w+)}/sU', "[\\1]", $bufer5);

	// template
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/design.tpl");

	//header
	include "header.inc";
	
	$tpl->assign('TITLE',TITLEADMIN_DESIGN);
	$tpl->assign('TITLEPAGE',TITLEADMIN_PAGE_DESIGN);
	$tpl->assign('HELP',INFO_DESIGN);
	
	if($error) $tpl->assign('ERROR_ALERT',$error);
	if($success) $tpl->assign('MSG_ALERT',$success);
			
	// menu
	include "menu.inc";			

	$bufer1 = htmlspecialchars($bufer1);
	$bufer2 = htmlspecialchars($bufer2);
	$bufer3 = htmlspecialchars($bufer3);
	$bufer4 = htmlspecialchars($bufer4);
	$bufer5 = htmlspecialchars($bufer5);

	//form
	$tpl->assign('PHP_SELF', $_SERVER['PHP_SELF']);
	$tpl->assign('STR_FILE', STR_FILE);
	$tpl->assign('BUFER1', $bufer1);
	$tpl->assign('BUFER2', $bufer2);
	$tpl->assign('BUFER3', $bufer3);
	$tpl->assign('BUFER4', $bufer4);
	$tpl->assign('BUFER5', $bufer5);
	$tpl->assign('BUTTON_SAVE_CHANGES_IN', BUTTON_SAVE_CHANGES_IN);	

	//footer
	include "footer.inc";
		
	// Count a quantity of the links
	$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
		
	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
		
	$total = $result->fetch_assoc();

	// Clear the descriptor
	$result->close();
		
	$tpl->assign("TOTAL_LINKS", $total['COUNT(*)']);
	$tpl->assign("STR_HELP", STR_HELP);
		
	// print html page
	$tpl->display();	

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>
