<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

ob_start();

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();	
	
	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";	

	// Authenticate
	require "../lib/authenticate.inc";

	// Check variable transferred by the method GET
	if(!preg_match("|^[\d]*$|",$_GET['id_сat'])) exit();
	if(!preg_match("|^[\d]*$|",$_GET['logic'])) exit();
	if(!preg_match("|^[\d]*$|",$_GET['id_catalog'])) exit();

	// Shield a special characters	
	$_GET['search'] = $dbh->real_escape_string($_GET['search']);
	$_GET['id_cat'] = $dbh->real_escape_string($_GET['id_cat']);
	$_GET['id_catalog'] = $dbh->real_escape_string($_GET['id_catalog']);
	$_GET['logic'] = $dbh->real_escape_string($_GET['logic']);	
	$_POST['id_link'] = $dbh->real_escape_string($_POST['id_link']);
	
	if(!empty($_POST['action'])){
		$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];
		$result = $dbh->query($query);

		if(!$result) { throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); }
		
		$success = MSG_LINK_REMOVED;
	}
		
	// Element of pagination
	$all_number_links = $settings['all_number_links'] ? $settings['all_number_links'] : 5;	

	$page = $_GET['page'];
	if(empty($page)) $page = 1;
	$begin = ($page - 1) * $all_number_links;	
	
	// template
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/edit.tpl");
	
	//header
	include "header.inc";
		
	$tpl->assign('TITLE', TITLEADMIN_LINKS);
	$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_LINKS);			
	$tpl->assign('HELP', INFO_LINKS);
			
	// menu
	include "menu.inc";		

	//alert
	if(!empty($success)){ 
		$tpl->assign('MSG_ALERT', $success);
	}
	
	//search form
	$tpl->assign('STR_FIND_SEARCHFORM', STR_FIND_SEARCHFORM);	
	$tpl->assign('STR_KEYWORDS_SEARCHFORM', STR_KEYWORDS_SEARCHFORM);	
	$tpl->assign('STR_SEARCH_IN_CATALOG_SEARCHFORM', STR_SEARCH_IN_CATALOG_SEARCHFORM);	
	$tpl->assign('STR_IT_DOESNT_MATTER_SEARCHFORM', STR_IT_DOESNT_MATTER_SEARCHFORM);	
	$tpl->assign('STR_MEETING_OF_KEYWORDS_SEARCHFORM', STR_MEETING_OF_KEYWORDS_SEARCHFORM);	
	$tpl->assign('STR_AT_LEAST_ONCE', STR_AT_LEAST_ONCE);	
	$tpl->assign('STR_ALL_WORDS_TOGETHER', STR_ALL_WORDS_TOGETHER);
	$tpl->assign('BUTTON_FIND', BUTTON_FIND);	

	$tpl->assign('ACTION', $_SERVER['PHP_SELF']);	
	$tpl->assign('SEARCH', urldecode($_GET['search']));
	$tpl->assign('LOGIC', $_POST['logic']);	
	$tpl->assign('ID_CATALOG', $_POST['id_catalog']);	
	$tpl->assign('OPTION', ShowCatalogList(0, 0));	
	
	$list_cat = '<table border="0" width="100%">';		
		
	$id_cat = $_GET['id_cat'] ? $_GET['id_cat'] : 0;	
					
	$query = "SELECT * FROM ".DB_CATALOG." WHERE id_parent=".$id_cat." ORDER BY name";
	$result = $dbh->query($query);
	
	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

	$arraycat = array();
		
	while($row = $result->fetch_array())
	{
		$arraycat[] = array($row['name'], $row['id_cat']); 
	}

	$result->close();
		
	$total = count($arraycat);

	$number = (int)($total / $settings['columns_number']);
	if((float)($total / $settings['columns_number']) - $number != 0) $number++;
	
	$rowPrintCat = $tpl->fetch('PRINT_CAT');
	
	// Form an array
	for($i = 0; $i < $number; $i++){
		for($j = 0; $j < $settings['columns_number']; $j++){
			$arr[$i][$j] = $arraycat[$j * $number + $i];
		}
	}		

	for($i = 0; $i < $number; $i++){
		$rowBlockCat = $rowPrintCat->fetch('ROW_CAT');

		for($j = 0; $j < $settings['columns_number']; $j++){
			
			$rowBlockFolder = $rowBlockCat->fetch('ROW_FOLDER');
			
			if($arr[$i][$j][0]){
				$rowBlockFolder->assign('FOLDER_LINK', "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']."?id_cat=".$arr[$i][$j][1]);
					
				$columns_number = (int)(100 / $settings['columns_number']);
				$rowBlockFolder->assign('COLUMNS_NUMBER', $columns_number);	
				$rowBlockFolder->assign('FOLDER_LINK_NAME', $arr[$i][$j][0]);
				$rowBlockFolder->assign('NUMBERSLINKS', ShowNumbersLinks($arr[$i][$j][1],0));
				$rowBlockFolder->assign('SHOWSUBCAT', ShowSubCat($arr[$i][$j][1],0,0));
			}
				
			$rowBlockCat->assign('ROW_FOLDER', $rowBlockFolder);
		}

		$rowPrintCat->assign('ROW_CAT', $rowBlockCat);
	}
		
	$tpl->assign('PRINT_CAT', $rowPrintCat);		
	
	if($_GET['id_cat']){	
		$tpl->assign('ID_CAT', $_GET['id_cat']);
	
		$arraypathway = Array();
		$arraypathway= topbarmenu($_GET['id_cat'], '');	
		$pathway = '<a href="edit.php">'.STR_HOME.'</a> '; 	

		for($i = 0; $i < count($arraypathway); $i++){
			$pathway .= '» <a href="http://'.$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'].'?id_cat='.$arraypathway[$i][0].'">'.$arraypathway[$i][1].'</a>';
		}

		$tpl->assign('TOPBARMENU', $pathway);		
	}
	
	if(!empty($_GET['id_cat']) AND empty($_GET['search'])){
		$query = "SELECT * FROM ".DB_CATALOG." WHERE id_cat = ".$_GET['id_cat'];
		$result = $dbh->query($query);

		if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
			
		$category = $result->fetch_array();
	
		$tpl->assign('CATNAME', $category['name']);
	
		$result->close();	
		
		$query = "SELECT *,c.name AS catname, l.name AS name, l.description AS description FROM ".DB_LINKS." l LEFT JOIN ".DB_CATALOG." c ON l.id_cat = c.id_cat WHERE l.id_cat = ".$_GET['id_cat']." AND status = 'show' ORDER BY time DESC LIMIT ".$begin.", ".$all_number_links."";
		$result = $dbh->query($query);

		if(!$result) { throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); }
		
		if($result->num_rows > 0){
			while($row = $result->fetch_array()){
				if(!empty($row['htmlcode_banner']))
					$htmlcode_banner = $row['htmlcode_banner'];
				else 
					$htmlcode_banner = '<a href="http://'.$row['url'].'" target=_blank><img border="0" width="88" height="31" src="./images/noimage.gif"></a>';
						
				$rowBlock = $tpl->fetch('ROW_LINKS');
				
				$rowBlock->assign('ACTION', 'editlink.php?id_link='.$row["id_link"]);				
				$rowBlock->assign('HTMLCODE_BANNER', $htmlcode_banner);
				$rowBlock->assign('URL', $row['url']);
				$rowBlock->assign('NAME', $row['name']);
				$rowBlock->assign('DESCRIPTION', $row['description']);
				$rowBlock->assign('STR_ADDED', STR_ADDED);
				$rowBlock->assign('TIME', $row["time"]);
				$rowBlock->assign('ID_LINK', $row["id_link"]);				
				$rowBlock->assign('ID_CAT', $_GET['id_cat']);				
				$rowBlock->assign('STR_NUMBER_OF_CLICKS', STR_NUMBER_OF_CLICKS);
				$rowBlock->assign('COUNT', $row['count']);			
				$rowBlock->assign('SHOW_PR', $settings['show_pr']);
				$rowBlock->assign('SHOW_CY', $settings['show_cy']);				
				$rowBlock->assign('BUTTON_EDIT', BUTTON_EDIT);
				$rowBlock->assign('BUTTON_REMOVE', BUTTON_DELETE);			
				
				$tpl->assign('ROW_LINKS', $rowBlock);					
			}
				
			// Count a quantity of the links
			$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE id_cat = ".$_GET['id_cat']." AND status = 'show'";
			$result = $dbh->query($query);
			
			if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
			
			$total = $result->fetch_assoc();

			// Clear the descriptor
			$result->close();

			$number = intval(($total['COUNT(*)'] - 1) / $all_number_links) + 1;
				
			if($page != 1) {
				$pervpage = '<a href="'.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page=1">&lt;&lt;</a>';
				$perv = '<a href="'.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page - 1).'">&lt;</a>'; 
			}

			if($page != $number) {
				$nextpage = '<a href="'.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page + 1).'">&gt;</a>'; 
				$next = '<a href="'.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.$number.'">&gt;&gt;</a>';
			}									

			if($page - 2 > 0) $page2left = '<a href="'.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page - 2).'">...'.($page - 2).'</a>';
			if($page - 1 > 0) $page1left = '<a href="'.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page - 1).'">'.($page - 1).'</a>';
			if($page + 2 <= $number) $page2right = '<a href="'.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page + 2).'">'.($page + 2).'...</a>';
			if($page + 1 <= $number) $page1right = '<a href="'.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page + 1).'">'.($page + 1).'</a>';				
				
			if($number > 1){
				$paginationBlock = $tpl->fetch('pagination');	
				$paginationBlock->assign('CURRENT_PAGE','<a>'.$page.'</a>');
				$paginationBlock->assign('STR_PAGES', STR_PAGES);
				$paginationBlock->assign('PAGE1RIGHT', $page1right);
				$paginationBlock->assign('PAGE2RIGHT', $page2right);

				$paginationBlock->assign('PAGE1LEFT', $page1left);
				$paginationBlock->assign('PAGE2LEFT', $page2left);

				$paginationBlock->assign('PERVPAGE', $pervpage);
				$paginationBlock->assign('NEXTPAGE', $nextpage);
	
				$paginationBlock->assign('PERV', $perv);
				$paginationBlock->assign('NEXT', $next);
			
				$tpl->assign('pagination', $paginationBlock);				
			}	
				
		}else{
			$tpl->assign('MSG_NOTLINKS', MSG_NOTLINKS);
		}
	}

	// Print the result of search
	if(!empty($_GET['search'])){
		$search = stripslashes(trim(urldecode($_GET['search'])));

		if(strlen($search) >= 3){
			$search_quantity_char = '';
			$temp = strtok($search," ");
			$temp = "$temp*";
				
			$logstr = $_GET['logic'] == 1 ? "and" : "or";

			if($_GET['id_catalog'] == 0) 
				$tmp2 = "AND status='show'";
			else 
				$tmp2 = "AND status='show' AND id_cat=".$_GET['id_catalog'];
				
			while ($temp)
			{
				if($is_query) 
					$tmp1 .= " $logstr MATCH (`name`,`description`,`email`,`keywords`,`full_description`) AGAINST ('$temp' IN BOOLEAN MODE) $tmp2";
				else  
					$tmp1 .= "MATCH (`name`,`description`,`email`,`keywords`,`full_description`) AGAINST ('$temp' IN BOOLEAN MODE) $tmp2";

				$is_query = true;
				$temp = strtok(" ");
			}			
			
			$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE ".$tmp1."";
			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); }
			
			$total = $result->fetch_assoc();
			$result->close();

			$number = intval(($total['COUNT(*)'] - 1) / $all_number_links) + 1;

			if($page != 1) {
				$pervpage = '<a href="'.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page=1">&lt;&lt;</a>';
				$perv = '<a href="'.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page - 1).'">&lt;</a>'; 
			}

			if($page != $number) {
				$nextpage = '<a href="'.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page + 1).'">&gt;</a>'; 
				$next = '<a href="'.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.$number.'">&gt;&gt;</a>';
			}									

			if($page - 2 > 0) $page2left = '<a href="'.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page - 2).'">...'.($page - 2).'</a>';
			if($page - 1 > 0) $page1left = '<a href="'.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page - 1).'">'.($page - 1).'</a>';
			if($page + 2 <= $number) $page2right = '<a href="'.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page + 2).'">'.($page + 2).'...</a>';
			if($page + 1 <= $number) $page1right = '<a href="'.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page + 1).'">'.($page + 1).'</a>';
			
			if($number > 1){
				$paginationBlock = $tpl->fetch('pagination');	
				$paginationBlock->assign('CURRENT_PAGE','<a>'.$page.'</a>');
				$paginationBlock->assign('STR_PAGES', STR_PAGES);
				$paginationBlock->assign('PAGE1RIGHT', $page1right);
				$paginationBlock->assign('PAGE2RIGHT', $page2right);

				$paginationBlock->assign('PAGE1LEFT', $page1left);
				$paginationBlock->assign('PAGE2LEFT', $page2left);

				$paginationBlock->assign('PERVPAGE', $pervpage);
				$paginationBlock->assign('NEXTPAGE', $nextpage);
	
				$paginationBlock->assign('PERV', $perv);
				$paginationBlock->assign('NEXT', $next);
			
				$tpl->assign('pagination', $paginationBlock);			
			}				
				
			$tpl->assign('CATNAME', STR_SEARCH_RESULT);
			
			$query = "SELECT * FROM ".DB_LINKS."
						WHERE ".$tmp1."
						GROUP BY id_link
						ORDER BY time DESC
						LIMIT ".$begin.", ".$all_number_links."";
						
			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }			
			
			if($result->num_rows > 0){
				while($row = $result->fetch_array())
				{
					if(!empty($row['htmlcode_banner']))
						$htmlcode_banner = $row['htmlcode_banner'];
					else 
						$htmlcode_banner = '<a href="http://'.$row['url'].'" target=_blank><img border="0" width="88" height="31" src="./images/noimage.gif"></a>';
						
					$rowBlock = $tpl->fetch('ROW_LINKS');
				
					$rowBlock->assign('ACTION', 'editlink.php?id_link='.$row["id_link"]);					
					$rowBlock->assign('HTMLCODE_BANNER', $htmlcode_banner);
					$rowBlock->assign('URL', $row['url']);
					$rowBlock->assign('NAME', $row['name']);
					$rowBlock->assign('DESCRIPTION', $row['description']);
					$rowBlock->assign('STR_ADDED', STR_ADDED);
					$rowBlock->assign('TIME', $row["time"]);
					$rowBlock->assign('ID_LINK', $row["id_link"]);
					$rowBlock->assign('STR_NUMBER_OF_CLICKS', STR_NUMBER_OF_CLICKS);
					$rowBlock->assign('COUNT', $row['count']);
				
					$rowBlock->assign('BUTTON_EDIT', BUTTON_EDIT);
					$rowBlock->assign('BUTTON_REMOVE', BUTTON_DELETE);
				
					$tpl->assign('ROW_LINKS', $rowBlock);			
				}			
				
				if($number > 1){
					$blockPagination = $tpl->fetch('pagination');	
					$blockPagination->assign('STR_PAGES', STR_PAGES);			
					$blockPagination->assign('PERVPAGE', $pervpage);			
					$blockPagination->assign('PAGE2LEFT', $page2left);			
					$blockPagination->assign('PAGE1LEFT', $page1left);			
					$blockPagination->assign('PAGE', $page);			
					$blockPagination->assign('PAGE1RIGHT', $page1right);			
					$blockPagination->assign('PAGE2RIGHT', $page2right);			
					$blockPagination->assign('NEXTPAGE', $nextpage);
			
					$tpl->assign('pagination', $blockPagination);			
				}				
			}
			else $tpl->assign('MSG_SEARCH_NOTFOUND', MSG_SEARCH_NOTFOUND);
			
			$result->close();

		} else $tpl->assign('MSG_SEARCH_QUANTITY_CHARCTER', MSG_SEARCH_QUANTITY_CHARCTER);
	}	
	
	//footer
	include "footer.inc";
		
	// Count a quantity of the links
	$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
		
	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
		
	$total = $result->fetch_assoc();

	// Clear the descriptor
	$result->close();
		
	$tpl->assign("TOTAL_LINKS", $total['COUNT(*)']);	
	$tpl->assign("STR_HELP", STR_HELP);
		
	// print html page
	$tpl->display();		

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>