<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

ob_start();

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();	
	
	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";	

	// Authenticate
	require "../lib/authenticate.inc";

	// Shield a special characters
	$_POST['name'] = $dbh->real_escape_string($_POST['name']);
	$_POST['description'] = $dbh->real_escape_string($_POST['description']);
	$_POST['keywords'] = $dbh->real_escape_string($_POST['keywords']);
	$_POST['id_cat'] = $dbh->real_escape_string($_POST['id_cat']);
	$_POST['id_parent'] = $dbh->real_escape_string($_POST['id_parent']);
	$_POST['new_id_cat'] = $dbh->real_escape_string($_POST['new_id_cat']);

	$error = Array();

	if(!empty($_POST["action"])){
		$_POST['name'] = htmlspecialchars(trim($_POST['name']));
		$_POST['description'] = trim($_POST['description']);
		$_POST['keywords'] = trim($_POST['keywords']);

		// Check whether is exist name of catalog
		if(empty($_POST['name'])){
			$error[] = MSG_ERROR_FILL_CAT_NAME;
		}
		
		if(!empty($_FILES["image"]["name"])){
			$size = filesize ($_FILES['image']['tmp_name']);
			
			if($size / 1024 > 100){			
				$error[] = str_replace('%LIMIT%','50',MSG_ERROR_FILESIZE);	
			}			
		}

		// Form SQL-query to edit data
		if(empty($error)){
			if($_POST['new_id_cat'] == 0) 
				$_POST['new_id_cat'] = 0;
			else
				$_POST['new_id_cat'] = $_POST['new_id_cat'];
		
			if(empty($_FILES['image']['tmp_name'])){		
				if($_POST['removepic'] == 'on'){
					$update = "UPDATE ".DB_CATALOG." SET name = '".$_POST['name']."',
														description = '".$_POST['description']."',
														keywords = '".$_POST['keywords']."',
														image = '',
														image_mime  = '',
														id_parent = ".$_POST['new_id_cat']."
							WHERE id_cat = ".$_POST['id_cat'];
				}
				else {
					$update = "UPDATE ".DB_CATALOG." SET name = '".$_POST['name']."',
														description = '".$_POST['description']."',
														keywords = '".$_POST['keywords']."',
														id_parent = ".$_POST['new_id_cat']."
								WHERE id_cat = ".$_POST['id_cat'];
				}
			}
			else{
				$ext = strrchr($_FILES["image"]["name"], ".");

				if(preg_match('/\.(jpg|jpeg|png|gif)$/i', $ext)){			
					$tmp = $_FILES['image']['tmp_name'];
					$original = file_get_contents($tmp);
					$image_mime = $_FILES["image"]["type"];
					$image = $dbh->real_escape_string(image_convert($original, 80, 80, $image_mime));					
				}	
				
				$update = "UPDATE ".DB_CATALOG." SET name = '".$_POST['name']."',
													description = '".$_POST['description']."',
													keywords = '".$_POST['keywords']."',
													image = '".$image."',
													image_mime = '".$image_mime."',
													id_parent = ".$_POST['new_id_cat']."
							WHERE id_cat = ".$_POST['id_cat'];
			}					  

			$result = $dbh->query($update);

			if($result){
				// Return to back if a query was executed successfully
				header("Location: category.php?id_parent=".$_POST['id_parent']);
				exit; 
			}
			else { throw new ExceptionMySQL($dbh->error,$update,"Error executing SQL query!"); }
		}
	}
	
	$_REQUEST['id_cat'] = $dbh->real_escape_string($_REQUEST['id_cat']);	

	// template
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/editcategory.tpl");
		
	//header
	include "header.inc";
		
	$tpl->assign('TITLE', TITLEADMIN_EDITCATEGORY);
	$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_EDITCATEGORY);	
	$tpl->assign('HELP', INFO_EDITCATEGORY);	
	
	//show errors
	if(count($error) > 0){
		$errorBlock = $tpl->fetch('show_errors');
		$errorBlock->assign('STR_IDENTIFIED_FOLLOWING_ERRORS',STR_IDENTIFIED_FOLLOWING_ERRORS);
	
		foreach($error as $row){
			$rowBlock = $errorBlock->fetch('row');
			$rowBlock->assign('ERROR', $row);
			$errorBlock->assign('row', $rowBlock);
		}
		
		$tpl->assign('show_errors', $errorBlock);
	}
			
	// menu
	include "menu.inc";		
								
	// Get the data to edit category
	$query = "SELECT * FROM ".DB_CATALOG." WHERE id_cat = ".$_REQUEST['id_cat'];
	$result = $dbh->query($query);

	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

	$row = $result->fetch_array();
	$result->close();

	if(empty($_POST['name']) AND empty($_POST['id_cat'])) { $_POST['name'] = $row['name']; }
	if(empty($_POST['description']) AND empty($_POST['id_cat'])) { $_POST['description'] = $row['description']; }
	if(empty($_POST['keywords']) AND empty($_POST['id_cat'])) { $_POST['keywords'] = $row['keywords']; }
	if(empty($_POST['id_parent']) AND empty($_POST['id_cat'])) { $_POST['id_parent'] = $row['id_parent']; }	

	//form
	$tpl->assign('STR_REQUIRED_FIELDS', STR_REQUIRED_FIELDS);	
	$tpl->assign('STR_GO_BACK', STR_GO_BACK);
	$tpl->assign('STR_NO', STR_NO);
	$tpl->assign('STR_CATEGORY_NAME', STR_CATEGORY_NAME);		
	$tpl->assign('STR_CATEGORY_DESCRIPTION', STR_CATEGORY_DESCRIPTION);
	$tpl->assign('STR_CATEGORY_KEYWORDS', STR_CATEGORY_KEYWORDS);		
	$tpl->assign('STR_CATEGORY', STR_CATEGORY);		
	$tpl->assign('STR_CATEGORY_IMAGE', STR_CATEGORY_IMAGE);		
	$tpl->assign('STR_REMOVE_PIC', STR_REMOVE_PIC);		

	$query = "SELECT * FROM ".DB_CATALOG." WHERE id_parent = ".$_REQUEST['id_cat'];
	$result = $dbh->query($query);
			
	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
								
	if($result->num_rows == 0){		
		$tpl->assign('OPTION',ShowCategoryList(0, 0, $_REQUEST['id_cat']));									
	}

	$result->close();	

	//value
	$tpl->assign('PHP_SELF', $_SERVER['PHP_SELF']);		
	$tpl->assign('NAME', $_POST['name']);		
	$tpl->assign('DESCRIPTION', $_POST['description']);		
	$tpl->assign('KEYWORDS', $_POST['keywords']);		
	$tpl->assign('ID_PARENT', $_POST['id_parent']);
	$tpl->assign('ID_CAT', $row['id_cat']);
		
	$tpl->assign('BUTTON', STR_EDIT);		

	//footer
	include "footer.inc";
		
	// Count a quantity of the links
	$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
		
	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
		
	$total = $result->fetch_assoc();

	// Clear the descriptor
	$result->close();
		
	$tpl->assign("TOTAL_LINKS", $total['COUNT(*)']);
	$tpl->assign("STR_HELP", STR_HELP);
		
	// print html page
	$tpl->display();	

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>
