<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

ob_start();

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";
		
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();

	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";	

	// Authenticate
	require "../lib/authenticate.inc";

	$error = Array();

	$edit = $_POST["edit"];

	if(!empty($_POST["action"])){
		$_POST["name"] = stripslashes(htmlspecialchars(trim($_POST["name"])));
		$_POST['url'] = strtolower(trim($_POST['url']));
		$_POST['reciprocal_link'] =  strtolower(trim($_POST['reciprocal_link']));
		$_POST["email"] = strtolower(trim($_POST["email"]));
		$_POST["description"] = stripslashes(htmlspecialchars(trim($_POST["description"])));
		$_POST["full_description"] = stripslashes(htmlspecialchars(trim($_POST["full_description"])));
		$_POST["keywords"] = htmlspecialchars(trim($_POST["keywords"]));
		$_POST["htmlcode_banner"] = stripslashes(trim($_POST["htmlcode_banner"]));

		$check_link = $_POST['check_link'] == 'on'? 'yes' : 'no';

		// Cut out http:// from the url of site
		if(!empty($_POST["url"])){
			if(substr($_POST["url"], 0, 7) == "http://") $_POST["url"] = str_replace('http://','',$_POST["url"]);
			if(strpos($_POST["url"],'/') > 0) list($_POST["url"]) = explode('/',$_POST["url"]);
		}

		// Cut out http:// from the url address of reciprocal link
		if(!empty($_POST["url_link"])){
			if(substr(strtolower($_POST["reciprocal_link"]), 0, 7) == "http://") $_POST["reciprocal_link"] = str_replace('http://','',$_POST["reciprocal_link"]);
		}

		// Cut out all unnecessary tags and javascripts from HTML code of banner
		$_POST["htmlcode_banner"] = cuttags($_POST["htmlcode_banner"]);

		// Check category is chosen, if not then print error
		if($_POST["id_cat"] == 0){
			$error[] = MSG_ERROR_CHOOSE_CATEGORY;
		}

		// Check the email on valid
		if(!empty($_POST["email"]) and check_email($_POST["email"])){
			$error[] = MSG_ERROR_WRONG_EMAIL;
		}

		// Check url on valid
		if(!empty($_POST["url"]) and check_url($_POST["url"])){
			$error[] = MSG_ERROR_WRONG_URL;
		}

		// Count the number of characters of brief description, if it more than a limit then print error
		if(!empty($_POST["description"]) and len_description($_POST["description"])){
			$error[] = MSG_ERROR_SHORT_DESC_WITHOUT_SPACES;
		}

		// Count the number of characters of full description, if it more than a limit then print error
		if(!empty($_POST["full_description"]) and len_description($_POST["full_description"])){
			$error[] = MSG_ERROR_FULL_DESC_WITHOUT_SPACES;
		}

		// Check HTML code of banner on valid
		if(!empty($_POST["htmlcode_banner"])){
			// check htmlcode of banner
			if(check_htmlcode_banner($_POST["htmlcode_banner"])){
				$error[] = MSG_ERROR_WRONG_HTML_BANNER;
			}
			else{
				// check image size of banner
				if(check_size_banner($_POST["htmlcode_banner"])){
					$error[] = MSG_ERROR_SIZE_BANNER;
				}

				// check image type of banner
				if(check_type_image_banner($_POST["htmlcode_banner"])){
					$error[] = MSG_ERROR_EXEND_BANNER;
				}
			}
		}

		// Check all required fields is filled
		// Check site name, if its value is empty print error
		if(empty($_POST["name"])){
			$error[] = MSG_ERROR_NOFILL_NAME;
		}

		// Check site address, if its value is empty print error
		if(empty($_POST["url"])){
			$error[] = MSG_ERROR_NOFILL_URL;
		}

		// Check reciprocal link, if its value is empty print error
		if(empty($_POST["description"])){
			$error[] = MSG_ERROR_NOFILL_BRIEFDESC;
		}

		// Check email, if its value is empty print error
		if(empty($_POST["full_description"])){
			$error[] = MSG_ERROR_NOFILL_FULLDESC;
		}

		// Shield a special characters		
		$_POST["name"] = $dbh->real_escape_string($_POST["name"]);
		$_POST["email"] = $dbh->real_escape_string($_POST["email"]);
		$_POST["keywords"] = $dbh->real_escape_string($_POST["keywords"]);
		$_POST["url"]  = $dbh->real_escape_string($_POST["url"]);
		$_POST["reciprocal_link"] = $dbh->real_escape_string($_POST["reciprocal_link"]);
		$_POST["description"] = $dbh->real_escape_string($_POST["description"]);
		$_POST["full_description"] = $dbh->real_escape_string($_POST["full_description"]);
		$_POST["htmlcode_banner"] = $dbh->real_escape_string($_POST["htmlcode_banner"]);
		$_POST["id_cat"] = $dbh->real_escape_string($_POST["id_cat"]);		
		
		$_POST['check_link'] = $_POST['check_link'] == 'on' ?  'yes' : 'no';

		// Add changes if not any errors
		if(count($error) == 0){
			// Form SQL-query to edit data
			$update = "UPDATE ".DB_LINKS." SET name = '".$_POST["name"]."',
											url = '".$_POST["url"]."',
											reciprocal_link = '".$_POST["reciprocal_link"]."',
											email = '".$_POST["email"]."',
											keywords = '".$_POST["keywords"]."',
											description = '".$_POST["description"]."',
											full_description = '".$_POST["full_description"]."',
											htmlcode_banner = '".$_POST["htmlcode_banner"]."',
											id_cat = '".$_POST['id_cat']."',
											check_link = '".$_POST['check_link']."'
							WHERE id_link = '".$_POST['id_link']."'";

			$result = $dbh->query($update);

			if($result){
				$success = MSG_CHANGES_ADDED;
			}
			else { throw new ExceptionMySQL($dbh->error,$update,"Error executing SQL query!"); }
		}
	}
	
	// Get data for edit the link
	$query = "SELECT * FROM ".DB_LINKS." WHERE id_link = ".$_REQUEST["id_link"];
	$result = $dbh->query($query);

	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

	$row = $result->fetch_array();

	$result->close();

	if(empty($_POST["name"]) and empty($edit)) { $_POST["name"] = $row['name']; }
	if(empty($_POST["reciprocal_link"]) and empty($edit)) { $_POST["reciprocal_link"] = $row['reciprocal_link']; }
	if(empty($_POST["url"]) and empty($edit)) { $_POST["url"] = $row['url']; }
	if(empty($_POST["email"]) and empty($edit)) { $_POST["email"] = $row['email']; }
	if(empty($_POST["keywords"]) and empty($edit)) { $_POST["keywords"] = $row['keywords']; }
	if(empty($_POST["description"]) and empty($edit)) { $_POST["description"] = $row['description']; }
	if(empty($_POST["full_description"]) and empty($edit)) { $_POST["full_description"] = $row['full_description']; }
	if(empty($_POST["htmlcode_banner"]) and empty($edit)) { $_POST["htmlcode_banner"] = $row['htmlcode_banner']; }
	if(empty($_POST["id_cat"]) and empty($edit)) { $_POST["id_cat"] = $row['id_cat']; }
	if(empty($_POST['check_link']) and empty($edit)) { $_POST['check_link'] = $row['check_link']; }	
	
	// include temlate
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/editlink.tpl");

	//header
	include "header.inc";
		
	$tpl->assign('TITLE', TITLEADMIN_EDITLINK);
	$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_EDITLINK);	
	$tpl->assign('HELP', INFO_EDITLINK);	

	if($success) $tpl->assign('MSG_ALERT',$success);	
	
	//show errors
	if(count($error) > 0){
		$errorBlock = $tpl->fetch('show_errors');
		$errorBlock->assign('STR_IDENTIFIED_FOLLOWING_ERRORS', STR_IDENTIFIED_FOLLOWING_ERRORS);
		$errorBlock->assign('MSG_ERROR_ERRORALREADY_EXISTS', MSG_ERROR_ERRORALREADY_EXISTS);
		$errorBlock->assign('MSG_ERROR_WAIT_VERIFICATION', MSG_ERROR_WAIT_VERIFICATION);
		$errorBlock->assign('MSG_ERROR_CHOOSE_CATEGORY', MSG_ERROR_CHOOSE_CATEGORY);
		$errorBlock->assign('MSG_ERROR_WRONG_URL', MSG_ERROR_WRONG_URL);
		$errorBlock->assign('MSG_ERROR_SAME_HOSTING', MSG_ERROR_SAME_HOSTING);
		$errorBlock->assign('MSG_ERROR_WRONG_EMAIL', MSG_ERROR_WRONG_EMAIL);
		$errorBlock->assign('MSG_ERROR_SHORT_DESC_WITHOUT_SPACES', MSG_ERROR_SHORT_DESC_WITHOUT_SPACES);
		$errorBlock->assign('MSG_ERROR_FULL_DESC_WITHOUT_SPACES', MSG_ERROR_FULL_DESC_WITHOUT_SPACES);
		$errorBlock->assign('MSG_ERROR_WRONG_HTML_BANNER', MSG_ERROR_WRONG_HTML_BANNER);
		$errorBlock->assign('MSG_ERROR_SIZE_BANNER', MSG_ERROR_SIZE_BANNER);
		$errorBlock->assign('MSG_ERROR_EXEND_BANNER', MSG_ERROR_EXEND_BANNER);
		$errorBlock->assign('MSG_ERROR_NOFILL_NAME', MSG_ERROR_NOFILL_NAME);
		$errorBlock->assign('MSG_ERROR_NOFILL_URL', MSG_ERROR_NOFILL_URL);
		$errorBlock->assign('MSG_ERROR_NOFILL_BRIEFDESC', MSG_ERROR_NOFILL_BRIEFDESC);
		$errorBlock->assign('MSG_ERROR_NOFILL_FULLDESC', MSG_ERROR_NOFILL_FULLDESC);
			
		foreach($error as $row){
			$rowBlock = $errorBlock->fetch('row');
			$rowBlock->assign('ERROR', $row);
			$errorBlock->assign('row', $rowBlock);
		}
		
		$tpl->assign('show_errors', $errorBlock);
	}
		
	// menu
	include "menu.inc";	
			
	//form
	$tpl->assign('STR_REQUIRED_FIELDS', STR_REQUIRED_FIELDS);
	$tpl->assign('STR_CATEGORY', STR_CATEGORY);
	$tpl->assign('STR_CHOOSE_CATEGORY', STR_CHOOSE_CATEGORY);
	$tpl->assign('STR_WEBSITE_NAME', STR_WEBSITE_NAME);	
	$tpl->assign('STR_URL', STR_URL);
	$tpl->assign('STR_ADDRESS_OF_RECIP_LINK_PAGE', STR_ADDRESS_OF_RECIP_LINK_PAGE);
	$tpl->assign('STR_EMAIL', STR_EMAIL);
	$tpl->assign('STR_ONLY_TEXT_NOT_HTML', STR_ONLY_TEXT_NOT_HTML);
	$tpl->assign('STR_KEYWORDS', STR_KEYWORDS);
	$tpl->assign('STR_LIST_SEPARATED_BY_COMMAS', STR_LIST_SEPARATED_BY_COMMAS);
	$tpl->assign('STR_BRIEF_DESCRIPTION', STR_BRIEF_DESCRIPTION);
	$tpl->assign('STR_ONLY_TEXT_NOT_HTML', STR_ONLY_TEXT_NOT_HTML);
	$tpl->assign('STR_TO_CHECK_THIS_LINK', STR_TO_CHECK_THIS_LINK);
	$tpl->assign('STR_FULL_DESCRIPTION', STR_FULL_DESCRIPTION);
	$tpl->assign('STR_HTML_CODE_OF_BANNER', STR_HTML_CODE_OF_BANNER);
	$tpl->assign('BUTTON', BUTTON_EDIT);
		
	//value		
	$tpl->assign('HIDDEN_FIELD', '');
	$tpl->assign('ACTION', $_SERVER['PHP_SELF']);
	$tpl->assign('OPTION', ShowTree(0, 0));
	$tpl->assign('NAME', $_POST['name']);
	$tpl->assign('URL', $_POST['url']);
	$tpl->assign('RECIPROCAL_LINK', $_POST['reciprocal_link']);
	$tpl->assign('EMAIL', $_POST['email']);		
	$tpl->assign('KEYWORDS', $_POST['keywords']);		
	$tpl->assign('DESCRIPTION', $_POST['description']);
	$tpl->assign('FULL_DESCRIPTION', $_POST{'full_description'});
	$tpl->assign('FULL_DESCRIPTION', $_POST['htmlcode_banner']);
	$tpl->assign('ID_CAT', $_POST['id_cat']);
	$tpl->assign('ID_LINK', $row['id_link']);
	$tpl->assign('CHECK_LINK', $_POST['check_link']);	
			
	//footer
	include "footer.inc";
		
	// Count a quantity of the links
	$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
		
	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
		
	$total = $result->fetch_assoc();

	// Clear the descriptor
	$result->close();
		
	$tpl->assign("TOTAL_LINKS", $total['COUNT(*)']);
	$tpl->assign("STR_HELP", STR_HELP);
		
	// print html page
	$tpl->display();	

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>