<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

ob_start();

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";
	
	$_POST['id_link'] = $dbh->real_escape_string($_POST['id_link']);
	$_REQUEST['id'] = $dbh->real_escape_string($_REQUEST['id']);

	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();

	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";	

	// Authenticate
	require "../lib/authenticate.inc";

	if(!preg_match("|^[\d]*$|",$_REQUEST['id'])) exit();
	
	if(!empty($_POST["action"])){
		switch ($_POST['event'])
		{
			case add:

				$query = "UPDATE ".DB_LINKS." SET status = 'show' WHERE id_link = ".$_POST['id_link'];

				if($dbh->query($query)){
					$query = "SELECT * FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];
					$result = $dbh->query($query);

					if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

					$links = $result->fetch_array();

					$result->close();

					sendMailAdd($links, STR_SUBJECT_ADD);

					$success = MSG_LINK_ADDED;
					
				}
				else throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!");

			break;

			// Remove link
			case delete:

			  $query = "SELECT * FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];
			  $result = $dbh->query($query);

			  if(!$result) throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!");

			  $links = $result->fetch_array();

			  $result->close();

			  $delete = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];

			  if($dbh->query($delete)){
				 // Send email to the user about the link has not passed moderation
				 sendMailNoAdd($links, STR_SUBJECT_NOADD);

				 $success = MSG_LINK_REMOVED;
			  }
			  else throw new ExceptionMySQL($dbh->error, $delete, "Error executing SQL query!"); 

			break;

			// Add link to black list
			case black:

				$query = "SELECT * FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];
				$result = $dbh->query($query);

				if(!$result) throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); 

				$links = $result->fetch_array();

				$result->close();

				$update = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_ADMIN."' WHERE id_link = ".$_POST['id_link'];

				if($dbh->query($update)){
					// Send email to the user about the link has not passed a moderation
					sendMailNoAdd($links, STR_SUBJECT_NOADD);

					$success = MSG_LINK_ADDED_TO_BLACKLIST;
				}
				else throw new ExceptionMySQL($dbh->error, $update, "Error executing SQL query!"); 
				
			break;

			// Automatic check the link
			case auto_check:

				if(!empty($settings['url'])){

					// Check is exist answer link on page with address $_POST['url_link']
					if(check_url_link ($_POST['reciprocal_link'], $_POST['url'])){
						// Add the link if it is
						$query = "UPDATE ".DB_LINKS." SET status = 'show', time_check = NOW() WHERE id_link = ".$_POST['id_link'];

						if($dbh->query($query)){
							// Send email to the user about the link was added
							$query = "SELECT * FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];
							$result = $dbh->query($query);

							if(!$result) throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!");

							$links = $result->fetch_array();

							$result->close();

							sendMailAdd($links, STR_SUBJECT_ADD);
							
							$success = MSG_CHECK_IS_COMPLETED;

						} else throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
					}
					else{
						// Remove the link or add to black list if it is not
						if($settings['add_to_blacklist'] == "yes"){
							$query = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_ABSENSE_RECIPROCAL."' WHERE id_link = ".$_POST['id_link'];
						}
						else{
							$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];
						}

						if($dbh->query($query))	{
							$success = MSG_CHECK_IS_COMPLETED;
						} else throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!");
					}
				}

			break;
		}
	}		
	
	// include temlate
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/index.tpl");
	
	//alert
	if(!empty($success)){ 
		$tpl->assign('MSG_ALERT', $success);
	}

	//header
	include "header.inc";	
	
	// menu
	include "menu.inc";	
	
	if(!empty($_REQUEST['id'])){	
		
		$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_NEW_LINKS);
		$tpl->assign('TITLE', TITLEADMIN_NEW_LINKS);
			
		$tpl->assign('HELP', INFO_NEW_LINKS);		

		$blockCheckLink = $tpl->fetch('check_link');
		$blockCheckLink->assign('STR_BACK', STR_GO_BACK);
	
		$query = "SELECT *,l.name as name, l.description as description,c.name as catname FROM ".DB_LINKS." l LEFT JOIN ".DB_CATALOG." c ON l.id_cat = c.id_cat WHERE id_link = ".$_REQUEST['id'];
		$result = $dbh->query($query);

		if(!$result) throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); 

		$links = $result->fetch_array();

		$result->close();
			
		if(!empty($links['htmlcode_banner'])) 
			$htmlcode_banner = $links['htmlcode_banner'];
		else 
			$htmlcode_banner = '<a href="http://'.$links['url'].'"><img border="0" width="88" height="31" src="../images/noimage.gif"></a>'; 

		$links['description'] = nl2br($links['description']);			
			
		$blockCheckLink->assign('HTMLCODE_BANNER', $htmlcode_banner);
		$blockCheckLink->assign('DESCRIPTION', $links['description']);			
		$blockCheckLink->assign('ID_LINK', $links['id_link']);			
		$blockCheckLink->assign('STR_NAME_OF_WEBSITE', STR_NAME_OF_WEBSITE);
		$blockCheckLink->assign('STR_DESCRIPTION_OF_WEBSITE', STR_DESCRIPTION_OF_WEBSITE);
		$blockCheckLink->assign('STR_CATEGORY', STR_CATEGORY);			
		$blockCheckLink->assign('STR_RECIP_URL_LINK', STR_RECIP_URL_LINK);
		$blockCheckLink->assign('STR_ADDED', STR_ADDED);
		$blockCheckLink->assign('BUTTON_ADD', BUTTON_ADD);
		$blockCheckLink->assign('BUTTON_DELETE', BUTTON_DELETE);
		$blockCheckLink->assign('BUTTON_TO_BLACKLIST', BUTTON_TO_BLACKLIST);
		$blockCheckLink->assign('PHP_SELF', $_SERVER['PHP_SELF']);			
		$blockCheckLink->assign('SHOW_CY', $settings['show_cy']);
		$blockCheckLink->assign('SHOW_PR', $settings['show_pr']);			
		
		$blockCheckLink->assign('URL', $links['url']);			
		$blockCheckLink->assign('NAME', $links['name']);			
		$blockCheckLink->assign('RECIPROCAL_LINK', $links['reciprocal_link']);		
		$blockCheckLink->assign('CATEGORY_NAME', $links['catname']);			
		$blockCheckLink->assign('TIME', $links['time']);			
				
		$tpl->assign('check_link', $blockCheckLink);		
	}
	else{
		// Elements of the pagination
		$all_number_new = $settings['all_number_new'] ? $settings['all_number_new'] : 5;			
			
		$page = $_GET['page'];

		if(empty($page)) $page = 1;
		$begin = ($page - 1) * $all_number_new;
			
		// header
		$tpl->assign('STR_VERSION', STR_VERSION);
		$tpl->assign('VERSION', $version);

		$tpl->assign('TITLE', TITLEADMIN_NEW_LINKS);
		$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_NEW_LINKS);	
			
		$tpl->assign('HELP', INFO_NEW_LINKS);		
			
		$blockNewLinks = $tpl->fetch('new_links');	

		$query = "SELECT *,l.name as name, l.description as description,c.name as catname FROM ".DB_LINKS." l LEFT JOIN ".DB_CATALOG." c ON l.id_cat = c.id_cat WHERE status = 'new' ORDER BY time DESC LIMIT ".$begin.", ".$all_number_new."";	
		$result = $dbh->query($query);
			
		if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
			
		if($result->num_rows > 0){
			while($row = $result->fetch_array())
			{
				$blockRow = $blockNewLinks->fetch('row');				
				$blockRow->assign('ID_LINK', $row['id_link']);
				$blockRow->assign('URL', $row['url']);				
				$blockRow->assign('NAME', $row['name']);				
				$blockRow->assign('DESCRIPTION', $row['description']);			
				$blockRow->assign('TIME', $row['time']);			
				$blockRow->assign('CATEGORY', $row['catname']);			
				$blockRow->assign('EMAIL', $row['email']);
			
				if(!empty($row['htmlcode_banner'])) 
					$htmlcode_banner = $row['htmlcode_banner'];
				else 
					$htmlcode_banner = '<a href="http://'.$row['url'].'" target=_blank><img border="0" width="88" height="31" src="../images/noimage.gif"></a>'; 
						
				$blockRow->assign('HTMLCODE_BANNER', $htmlcode_banner);	
				$blockRow->assign('SHOW_PR', $settings['show_pr']);	
				$blockRow->assign('SHOW_CY', $settings['show_cy']);		
				$blockRow->assign('STR_ADDED', STR_ADDED);
				$blockRow->assign('STR_CATEGORY', STR_CATEGORY);
				$blockRow->assign('STR_EMAIL', STR_EMAIL);
				$blockRow->assign('BUTTON_HANDCHECK', BUTTON_HANDCHECK);	
				$blockRow->assign('BUTTON_AUTOCHECK', BUTTON_AUTOCHECK);			
			
				$blockNewLinks->assign('row', $blockRow);	
			}					
		}
		else{
			$blockNewLinks->assign('MSG_NOTNEWLINKS', MSG_NOTNEWLINKS);
		}
			
		$result->close();			

		// Count a quantity of the links
		$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'new'";
		$result = $dbh->query($query);
			
		if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
			
		$total = $result->fetch_assoc();

		// Clear the descriptor
		$result->close();

		$number = intval(($total['COUNT(*)'] - 1) / $all_number_new) + 1;
			
		if($page != 1) {
			$pervpage = '<a href="'.$_SERVER['PHP_SELF'].'?page=1">&lt;&lt;</a>';
			$perv = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 1).'">&lt;</a>'; 
		}

		if($page != $number) {
			$nextpage = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 1).'">&gt;</a>'; 
			$next = '<a href="'.$_SERVER['PHP_SELF'].'?page='.$number.'">&gt;&gt;</a>';
		}									

		if($page - 2 > 0) $page2left = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 2).'">...'.($page - 2).'</a>';
		if($page - 1 > 0) $page1left = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page - 1).'">'.($page - 1).'</a>';
		if($page + 2 <= $number) $page2right = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 2).'">'.($page + 2).'...</a>';
		if($page + 1 <= $number) $page1right = '<a href="'.$_SERVER['PHP_SELF'].'?page='.($page + 1).'">'.($page + 1).'</a>';
			
		if($number > 1){
			$paginationBlock = $blockNewLinks->fetch('pagination');	
			$paginationBlock->assign('CURRENT_PAGE','<a>'.$page.'</a>');
			$paginationBlock->assign('STR_PAGES', STR_PAGES);
			$paginationBlock->assign('PAGE1RIGHT', $page1right);
			$paginationBlock->assign('PAGE2RIGHT', $page2right);

			$paginationBlock->assign('PAGE1LEFT', $page1left);
			$paginationBlock->assign('PAGE2LEFT', $page2left);

			$paginationBlock->assign('PERVPAGE', $pervpage);
			$paginationBlock->assign('NEXTPAGE', $nextpage);
	
			$paginationBlock->assign('PERV', $perv);
			$paginationBlock->assign('NEXT', $next);
			
			$blockNewLinks->assign('pagination', $paginationBlock);			
		}
			
		$tpl->assign('new_links', $blockNewLinks);
	}
	
	//footer
	include "footer.inc";
		
	// Count a quantity of the links
	$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
	
	if(!$result) throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!");
		
	$total = $result->fetch_assoc();

	// Clear the descriptor
	$result->close();
		
	$tpl->assign("TOTAL_LINKS", $total['COUNT(*)']);
	$tpl->assign("STR_HELP", STR_HELP);
		
	// print html page
	$tpl->display();
	
	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>