<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

ob_start();

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();	
	
	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";	

	// Authenticate
	require "../lib/authenticate.inc";
	
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/password.tpl");

	$error = Array();

	if(!empty($_POST["action"])){
		$_POST["current_password"] = trim($_POST["current_password"]);
		$_POST["password"] = trim($_POST["password"]);
		$_POST["password_again"] = trim($_POST["password_again"]);

		if(!$_POST["current_password"]){
			$error[] = MSG_ERROR_FILL_CURRENT_PASSWORD;
		}

		if(!$_POST["password"]){
			$error[] = MSG_ERROR_FILL_PASSWORD;
		}

		if(!$_POST["password_again"]){
			$error[] = MSG_ERROR_FILL_AGAIN_PASSWORD;
		}
	
		if($_POST["password"] and $_POST["password_again"] and $_POST["password"] != $_POST["password_again"]){
			$error[] = MSG_ERROR_PASSWORDS_DONT_MATCH;
		}
	
		if($_POST["current_password"]){
			$current_password = md5($_POST["current_password"]);
		
			if($passw_aut != $current_password){
				$error[] = MSG_ERROR_WRONG_PASSWORD;
			}
		}
	
		if(empty($error)){
			// Get hash of the password
			$password = md5(trim($_POST["password"]));

			// Form the SQL query on update
			$query = "UPDATE ".DB_AUT." SET passw = '".$password."'";

			if($dbh->query($query)){
				$success = MSG_PASSWORD_CHANGED;
			}
			else { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
		}
	}	
	
	//header
	include "header.inc";
		
	$tpl->assign('TITLE', TITLEADMIN_PASSWORD);
	$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_PASSWORD);		
	$tpl->assign('HELP', INFOADMIN_PASSWORD);
			
	// menu
	include "menu.inc";	
	
	if($success) $tpl->assign('MSG_ALERT',$success);	
	
	//errors
	$tpl->assign('MSG_ERROR_FILL_CURRENT_PASSWORD', MSG_ERROR_FILL_CURRENT_PASSWORD);
	$tpl->assign('MSG_ERROR_PASSWORDS_DONT_MATCH', MSG_ERROR_PASSWORDS_DONT_MATCH);
	$tpl->assign('MSG_ERROR_FILL_PASSWORD', MSG_ERROR_FILL_PASSWORD);		
	$tpl->assign('MSG_ERROR_FILL_AGAIN_PASSWORD', MSG_ERROR_FILL_AGAIN_PASSWORD);		
		
	//form
	$tpl->assign('ACTION', $_SERVER['PHP_SELF']);
	$tpl->assign('STR_CURRENT_PASSWORD', STR_CURRENT_PASSWORD);
	$tpl->assign('STR_NEW_PASSWORD', STR_NEW_PASSWORD);
	$tpl->assign('STR_NEW_PASSWORD_AGAIN', STR_NEW_PASSWORD_AGAIN);
	$tpl->assign('BUTTON_SAVE', BUTTON_SAVE);	

	// Report an errors
	if(count($error) > 0){
		$errorBlock = $tpl->fetch('show_errors');
		$errorBlock->assign('STR_IDENTIFIED_FOLLOWING_ERRORS', STR_IDENTIFIED_FOLLOWING_ERRORS);
			
		foreach($error as $row){
			$rowBlock = $errorBlock->fetch('row');
			$rowBlock->assign('ERROR', $row);
			$errorBlock->assign('row', $rowBlock);
		}
		
		$tpl->assign('show_errors', $errorBlock);
	}	

	//footer
	include "footer.inc";
		
	// Count a quantity of the links
	$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
		
	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
		
	$total = $result->fetch_assoc();

	// Clear the descriptor
	$result->close();
		
	$tpl->assign("TOTAL_LINKS", $total['COUNT(*)']);
	$tpl->assign("STR_HELP", STR_HELP);
		
	// print html page
	$tpl->display();	

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>
