<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

ob_start();

// config
require_once '../config/config.inc';

// check install
require_once "../lib/check_install.inc";

// Require necessary classes
require_once '../class/html_template/SeparateTemplate.php';
require_once "../class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "../lib/function.inc";
	require_once "../lib/connect.inc";
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();	
	
	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";	

	// Authenticate
	require "../lib/authenticate.inc";

	if(!empty($_POST["action"])){
		$_POST['all_number_links'] = trim($_POST['all_number_links']);	
		$_POST['all_number_new'] = trim($_POST['all_number_new']);		
		$_POST['columns_number'] = trim($_POST['columns_number']);	
		$_POST['number_chars_description_min'] = trim($_POST['number_chars_description_min']);	
		$_POST['number_chars_description_max'] = trim($_POST['number_chars_description_max']);	
		$_POST['number_chars_fulldescription_min'] = trim($_POST['number_chars_fulldescription_min']);	
		$_POST['number_chars_fulldescription_max'] = trim($_POST['number_chars_fulldescription_max']);	
		$_POST['number_html_chars'] = trim($_POST['number_html_chars']);	
		$_POST['email'] = trim($_POST['email']);	
		$_POST['rules'] = trim($_POST['rules']);	
		$_POST['htmlcode_site1'] = trim($_POST['htmlcode_site1']);	
		$_POST['htmlcode_site2'] = trim($_POST['htmlcode_site2']);	
		$_POST['htmlcode_site3'] = trim($_POST['htmlcode_site3']);	
		$_POST['htmlcode_banner1'] = trim($_POST['htmlcode_banner1']);
		$_POST['htmlcode_banner2'] = trim($_POST['htmlcode_banner2']);
		$_POST['htmlcode_banner3'] = trim($_POST['htmlcode_banner3']);	
		$_POST['template_mail_1'] = trim($_POST['template_mail_1']);	
		$_POST['template_mail_2'] = trim($_POST['template_mail_2']);	
		$_POST['template_mail_3'] = trim($_POST['template_mail_3']);	
		$_POST['template_mail_4'] = trim($_POST['template_mail_4']);	
		$_POST['template_mail_5'] = trim($_POST['template_mail_5']);	
		$_POST['template_mail_6'] = trim($_POST['template_mail_6']);	
		$_POST['template_mail_7'] = trim($_POST['template_mail_7']);	
		$_POST['from_add_message'] = trim($_POST['from_add_message']);	
		$_POST['number_reciprocal_links_limit'] = trim($_POST['number_reciprocal_links_limit']);	
		$_POST['check_interval'] = trim($_POST['check_interval']);
		$_POST['number_check'] = trim($_POST['number_check']);		
		$_POST['url'] = trim(strtolower($_POST['url']));
		if(substr($_POST['url'], 0, 7) == "http://") { $_POST['url'] = str_replace('http://','',$_POST['url']); }
		if(substr($_POST['url'], 0, 4) == "www.") { $_POST['url'] = str_replace('www.','',$_POST['url']); }
		if(strpos($_POST['url'],'/')>0) list($_POST['url']) = explode('/',$_POST['url']);		
		
		$_POST['order_views'] = (int)$_POST['order_views'];
		$_POST['order_links'] = (int)$_POST['order_links'];
		$_POST['static'] = (int)$_POST['static'];		
		$_POST['new_links_notification'] = $_POST['new_links_notification'] == "on" ? "yes" : "no";
		$_POST['add_links_without_check'] = $_POST['add_links_without_check'] == "on" ? "yes" : "no";
		$_POST['check_links'] = $_POST['check_links'] == "on" ? "yes" : "no";
		$_POST['limit_reciprocal_links'] = $_POST['limit_reciprocal_links'] == "on" ? "yes" : "no";
		$_POST['common_host'] =	$_POST['common_host'] == "on" ? "yes" : "no";
		$_POST['check_get_parameter'] = $_POST['check_get_parameter'] == "on" ? "yes" : "no";
		$_POST['add_to_blacklist'] = $_POST['add_to_blacklist'] == "on" ? "yes" : "no";
		$_POST['request_captcha'] = $_POST['request_captcha'] == "on" ? "yes" : "no";
		$_POST['show_cy'] = $_POST['show_cy'] == "on" ? "yes" : "no";
		$_POST['show_pr'] = $_POST['show_pr'] == "on" ? "yes" : "no";
		$_POST['check_url'] = $_POST['check_url'] == "on" ? "yes" : "no";		
		
		$_POST['language'] = $dbh->real_escape_string($_POST['language']);
		$_POST['all_number_links'] = $dbh->real_escape_string($_POST['all_number_links']);
		$_POST['all_number_new'] = $dbh->real_escape_string($_POST['all_number_new']);
		$_POST['columns_number'] = $dbh->real_escape_string($_POST['columns_number']);
		$_POST['number_chars_description_min'] = $dbh->real_escape_string($_POST['number_chars_description_min']);
		$_POST['number_chars_description_max'] = $dbh->real_escape_string($_POST['number_chars_description_max']);
		$_POST['number_chars_fulldescription_min'] = $dbh->real_escape_string($_POST['number_chars_fulldescription_min']);
		$_POST['number_chars_fulldescription_max'] = $dbh->real_escape_string($_POST['number_chars_fulldescription_max']);
		$_POST['number_html_chars'] = $dbh->real_escape_string($_POST['number_html_chars']);
		$_POST['url'] = $dbh->real_escape_string($_POST['url']);
		$_POST['email'] = $dbh->real_escape_string($_POST['email']);
		$_POST['rules'] = $dbh->real_escape_string($_POST['rules']);
		$_POST['htmlcode_site1'] = $dbh->real_escape_string($_POST['htmlcode_site1']);
		$_POST['htmlcode_site2'] = $dbh->real_escape_string($_POST['htmlcode_site2']);
		$_POST['htmlcode_site3'] = $dbh->real_escape_string($_POST['htmlcode_site3']);
		$_POST['htmlcode_banner1'] = $dbh->real_escape_string($_POST['htmlcode_banner1']);
		$_POST['htmlcode_banner2'] = $dbh->real_escape_string($_POST['htmlcode_banner2']);
		$_POST['htmlcode_banner3'] = $dbh->real_escape_string($_POST['htmlcode_banner3']);
		$_POST['template_mail_1'] = $dbh->real_escape_string($_POST['template_mail_1']);
		$_POST['template_mail_2'] = $dbh->real_escape_string($_POST['template_mail_2']);
		$_POST['template_mail_3'] = $dbh->real_escape_string($_POST['template_mail_3']);		
		$_POST['template_mail_4'] = $dbh->real_escape_string($_POST['template_mail_4']);		
		$_POST['template_mail_5'] = $dbh->real_escape_string($_POST['template_mail_5']);		
		$_POST['template_mail_6'] = $dbh->real_escape_string($_POST['template_mail_6']);		
		$_POST['template_mail_7'] = $dbh->real_escape_string($_POST['template_mail_7']);
		$_POST['from_add_message'] = $dbh->real_escape_string($_POST['from_add_message']);
		$_POST['number_reciprocal_links_limit'] = $dbh->real_escape_string($_POST['number_reciprocal_links_limit']);
		$_POST['check_interval'] = $dbh->real_escape_string($_POST['check_interval']);
		$_POST['number_check'] = $dbh->real_escape_string($_POST['number_check']);		
		
		
		$update = "UPDATE ".DB_SETTING." SET language = '".$_POST['language']."',
												all_number_links = ".$_POST['all_number_links'].",
												all_number_new = ".$_POST['all_number_new'].",
												columns_number = ".$_POST['columns_number'].",
												number_chars_description_min = ".$_POST['number_chars_description_min'].",
												number_chars_description_max = ".$_POST['number_chars_description_max'].",
												number_chars_fulldescription_min = ".$_POST['number_chars_fulldescription_min'].",
												number_chars_fulldescription_max = ".$_POST['number_chars_fulldescription_max'].",
												number_html_chars = ".$_POST['number_html_chars'].",
												order_views = '".$_POST['order_views']."',
												order_links = '".$_POST['order_links']."',
												url = '".$_POST['url']."',
												email = '".$_POST['email']."',
												new_links_notification = '".$_POST['new_links_notification']."',
												rules = '".$_POST['rules']."',
												htmlcode_site1 = '".$_POST['htmlcode_site1']."',
												htmlcode_site2 = '".$_POST['htmlcode_site2']."',
												htmlcode_site3 = '".$_POST['htmlcode_site3']."',
												htmlcode_banner1 = '".$_POST['htmlcode_banner1']."',
												htmlcode_banner2 = '".$_POST['htmlcode_banner2']."',
												htmlcode_banner3 = '".$_POST['htmlcode_banner3']."',
												template_mail_1 = '".$_POST['template_mail_1']."',
												template_mail_2 = '".$_POST['template_mail_2']."',
												template_mail_3 = '".$_POST['template_mail_3']."',
												template_mail_4 = '".$_POST['template_mail_4']."',
												template_mail_5 = '".$_POST['template_mail_5']."',
												template_mail_6 = '".$_POST['template_mail_6']."',
												template_mail_7 = '".$_POST['template_mail_7']."',
												add_links_without_check = '".$_POST['add_links_without_check']."',
												check_links = '".$_POST['check_links']."',
												limit_reciprocal_links = '".$_POST['limit_reciprocal_links']."',
												number_reciprocal_links_limit = ".$_POST['number_reciprocal_links_limit'].",
												common_host = '".$_POST['common_host']."',
												check_get_parameter = '".$_POST['check_get_parameter']."',
												add_to_blacklist = '".$_POST['add_to_blacklist']."',
												check_interval = ".$_POST['check_interval'].",
												number_check = ".$_POST['number_check'].",
												static = '".$_POST['static']."',
												request_captcha = '".$_POST['request_captcha']."',
												show_cy = '".$_POST['show_cy']."',
												show_pr = '".$_POST['show_pr']."',
												check_url = '".$_POST['check_url']."'";

		if($dbh->query($update)){
			if($_POST['static'] == 1){
				$root = strpos($_SERVER['REQUEST_URI'], "admin");
				$dir = substr($_SERVER['REQUEST_URI'], 0, $root);
				$content = "RewriteEngine on\r\nRewriteBase ".$dir."\r\nRewriteCond %{REQUEST_URI} \.html$\r\nRewriteRule ^page_([^/]+)_([^/\.]+)\.html$ index.php?id_cat=$1&page=$2 [L]\r\nRewriteCond %{REQUEST_URI} \.html$\r\nRewriteRule ^link_([^/]+)_([^/\.]+)\.html$ index.php?id_link=$1&page=$2 [L]\r\nRewriteCond %{REQUEST_URI} \.html$\r\nRewriteRule ^link_([^/]+)\.html$ index.php?id_link=$1 [L]\r\nRewriteCond %{REQUEST_URI} \.html$\r\nRewriteRule ^index\.html$ index.php [L]\r\n";
				$hfile = fopen("../.htaccess","w");

				fputs($hfile, $content);
				fclose($hfile);
			}

			if($_POST['static'] == 2){
				$hfile = fopen("../.htaccess","w");

				fputs($hfile, "");
				fclose($hfile);
			}

			$success = MSG_CHANGES_ADDED;
		}
		else { throw new ExceptionMySQL($dbh->error,$update,"Error executing SQL query!"); }
	}	
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");

	$settings = $result->fetch_array();

	$result->close();		

	// template
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/settings.tpl");
	
	//header
	include "header.inc";		
		
	$tpl->assign('TITLE', TITLEADMIN_SETTINGS);
	$tpl->assign('TITLEPAGE', TITLEADMIN_PAGE_SETTINGS);		
	$tpl->assign('HELP', INFO_SETTINGS);
	
	if($success) $tpl->assign('MSG_ALERT',$success);		
			
	// menu
	include "menu.inc";		
								
	if(empty($settings['url'])){
		if(substr($_SERVER['SERVER_NAME'],0,4) == "www.") { $settings['url'] = substr($_SERVER["SERVER_NAME"],4); }
		else { $settings['url'] = $_SERVER['SERVER_NAME']; }
	}

	$language_ru = $settings['language'] == "ru" ? 'selected="selected"' : ''; 
	$language_en = $settings['language'] == "en" ? 'selected="selected"' : ''; 
	$order_views1 = $settings['order_views'] == 1 ? 'checked="checked"' : '';
	$order_views2 = $settings['order_views'] == 2 ? 'checked="checked"' : '';
	$order_links1 = $settings['order_links'] == 1 ? 'checked="checked"' : '';
	$order_links2 = $settings['order_links'] == 2 ? 'checked="checked"' : '';
	$show_cy = $settings['show_cy'] == "yes" ? 'checked="checked"' : '';
	$show_pr = $settings['show_pr'] == "yes" ? 'checked="checked"' : '';
	$static1 = $settings['static'] == 1 ? 'checked="checked"' : '';
	$static2 = $settings['static'] == 2 ? 'checked="checked"' : '';
	$request_captcha = $settings['request_captcha'] == "yes" ? 'checked="checked"' : '';
	$new_links_notification = $settings['new_links_notification'] == "yes" ? 'checked="checked"' : '';
	$add_links_without_check = $settings['add_links_without_check'] == "yes" ? 'checked="checked"' : '';
	$check_links = $settings['check_links'] == "yes" ? '' : '';		
	$many_link = $settings['many_link'] == "yes" ? 'checked="checked"' : "";
	$common_host = $settings['common_host'] == "yes" ? 'checked="checked"' : "";
	$query_check = $settings['query_check'] == "yes" ? 'checked="checked"' : "";
	$no_add_link = $settings['no_add_link'] == "yes" ? 'checked="checked"' : "";
	$black = $settings['black'] == "yes" ? 'checked="checked"' : "";
	$send_mail = $settings['send_mail'] == "yes" ? 'checked="checked"' : "";

	//form
	$tpl->assign("STR_INTERFACE_SETTINGS", STR_INTERFACE_SETTINGS);
	$tpl->assign("STR_LANGUAGE", STR_LANGUAGE);
	$tpl->assign("STR_LANG_RU", STR_LANG_RU);
	$tpl->assign("STR_LANG_EN", STR_LANG_EN);
	$tpl->assign("STR_ALL_NUMBER_LINKS", STR_ALL_NUMBER_LINKS);
	$tpl->assign("STR_ALL_NUMBER_NEW", STR_ALL_NUMBER_NEW);
	$tpl->assign("STR_COLUMNS_NUMBER", STR_COLUMNS_NUMBER);
	$tpl->assign("STR_ORDER_VIEWS", STR_ORDER_VIEWS);
	$tpl->assign("STR_BY_DATE", STR_BY_DATE);
	$tpl->assign("STR_BY_NUMBER", STR_BY_NUMBER);		
	$tpl->assign("STR_ORDER_LINKS", STR_ORDER_LINKS);		
	$tpl->assign("STR_BY_INCREACE", STR_BY_INCREACE);		
	$tpl->assign("STR_BY_DECREASE", STR_BY_DECREASE);				
	$tpl->assign("STR_SHOW_CY", STR_SHOW_CY);		
	$tpl->assign("STR_SHOW_PR", STR_SHOW_PR);	
	$tpl->assign("HINT_VIEW_OF_URL_ADDRESS", HINT_VIEW_OF_URL_ADDRESS);			
	$tpl->assign("STR_STATIC", STR_STATIC);
	$tpl->assign("STR_STATIC_URL", STR_STATIC_URL);		
	$tpl->assign("STR_DYNAMIC_URL", STR_DYNAMIC_URL);		
	$tpl->assign("STR_CATALOG_URL", STR_CATALOG_URL);		
	$tpl->assign("STR_ADMIN_EMAIL", STR_ADMIN_EMAIL);		
	$tpl->assign("STR_CATALOG_RULE", STR_CATALOG_RULE);	
	$tpl->assign("STR_FROM_ADD_MESSAGE", STR_FROM_ADD_MESSAGE);	
	$tpl->assign("STR_MSG_FOR_USER_AFTER_ADDITION", STR_MSG_FOR_USER_AFTER_ADDITION);		
	$tpl->assign("STR_HTMLCODE_SITE1", STR_HTMLCODE_SITE1);
	$tpl->assign("STR_HTMLCODE_SITE2", STR_HTMLCODE_SITE2);
	$tpl->assign("STR_HTMLCODE_SITE3", STR_HTMLCODE_SITE3);			
	$tpl->assign("STR_HTMLCODE_BANNER1", STR_HTMLCODE_BANNER1);		
	$tpl->assign("STR_HTMLCODE_BANNER2", STR_HTMLCODE_BANNER2);		
	$tpl->assign("STR_HTMLCODE_BANNER3", STR_HTMLCODE_BANNER3);		
	$tpl->assign("STR_LETTERS_TEMPLATES", STR_LETTERS_TEMPLATES);		
	$tpl->assign("STR_EMAIL_FOR_USER_ADD_MODER", STR_EMAIL_FOR_USER_ADD_MODER);		
	$tpl->assign("STR_EMAIL_FOR_USER_ADD_CATALOG", STR_EMAIL_FOR_USER_ADD_CATALOG);			
	$tpl->assign("STR_EMAIL_FOR_USER_HIDE_ABSENSE", STR_EMAIL_FOR_USER_HIDE_ABSENSE);		
	$tpl->assign("STR_EMAIL_FOR_USER_HIDE_PROHIB", STR_EMAIL_FOR_USER_HIDE_PROHIB);	
	$tpl->assign("STR_EMAIL_FOR_USER_PASSED", STR_EMAIL_FOR_USER_PASSED);		
	$tpl->assign("STR_EMAIL_FOR_USER_REMOVE", STR_EMAIL_FOR_USER_REMOVE);		
	$tpl->assign("STR_EMAIL_FOR_USER_ADD_NEW", STR_EMAIL_FOR_USER_ADD_NEW);		
	$tpl->assign("STR_CATALOG_SETTINGS", STR_CATALOG_SETTINGS);		
	$tpl->assign("STR_CHECK_INTERVAL", STR_CHECK_INTERVAL);		
	$tpl->assign("STR_NUMBER_CHECK", STR_NUMBER_CHECK);		
	$tpl->assign("STR_NUMBER_CHARS_DESCRIPTION", STR_NUMBER_CHARS_DESCRIPTION);		
	$tpl->assign("STR_NUMBER_CHARS_FULLDESCRIPTION", STR_NUMBER_CHARS_FULLDESCRIPTION);		
	$tpl->assign("STR_NUMBER_HTML_CHARS", STR_NUMBER_HTML_CHARS);		
	$tpl->assign("STR_REQUEST_CAPTCHA", STR_REQUEST_CAPTCHA);		
	$tpl->assign("STR_ADD_LINKS_WITHOUT_CHECK", STR_ADD_LINKS_WITHOUT_CHECK);		
	$tpl->assign("STR_CHECK_LINKS", STR_CHECK_LINKS);		
	$tpl->assign("STR_COMMON_HOST", STR_COMMON_HOST);	
	$tpl->assign("STR_CHECK_GET_PARAMETER", STR_CHECK_GET_PARAMETER);		
	$tpl->assign("STR_LIMIT_RECIPROCAL_LINKS", STR_LIMIT_RECIPROCAL_LINKS);		
	$tpl->assign("STR_ADD_TO_BLACKLIST", STR_ADD_TO_BLACKLIST);				
	$tpl->assign("STR_NEW_LINKS_NOTIFICATION", STR_NEW_LINKS_NOTIFICATION);		
	$tpl->assign("BUTTON_SAVE", BUTTON_SAVE);
	$tpl->assign("BUTTON_BY_DEFAULT", BUTTON_BY_DEFAULT);
		
	//value
	$tpl->assign("PHP_SELF", $_SERVER['PHP_SELF']);		
	$tpl->assign("LANGUAGE_OPTION", $settings['language']);		
	$tpl->assign("ORDER_VIEWS", $settings['order_views']);
	$tpl->assign("ORDER_LINKS", $settings['order_links']);		
	$tpl->assign("SHOW_CY", $settings['show_cy']);
	$tpl->assign("SHOW_PR", $settings['show_pr']);
	$tpl->assign("STATIC", $settings['static']);
	$tpl->assign("ALL_NUMBER_LINK", $settings['all_number_links']);		
	$tpl->assign("ALL_NUMBER_NEW", $settings['all_number_new']);		
	$tpl->assign("COLUMNS_NUMBER", $settings['columns_number']);		
	$tpl->assign("URL", $settings['url']);		
	$tpl->assign("EMAIL", $settings['email']);		
	$tpl->assign("RULES", $settings['rules']);		
	$tpl->assign("FROM_ADD_MESSAGE", $settings['from_add_message']);		
	$tpl->assign("HTMLCODE_SITE1", $settings['htmlcode_site1']);		
	$tpl->assign("HTMLCODE_SITE2", $settings['htmlcode_site2']);		
	$tpl->assign("HTMLCODE_SITE3", $settings['htmlcode_site3']);		
	$tpl->assign("HTMLCODE_BANNER1", $settings['htmlcode_banner1']);		
	$tpl->assign("HTMLCODE_BANNER2", $settings['htmlcode_banner2']);		
	$tpl->assign("HTMLCODE_BANNER3", $settings['htmlcode_banner3']);		
	$tpl->assign("TEMPLATE_MAIL_1", $settings['template_mail_1']);		
	$tpl->assign("TEMPLATE_MAIL_2", $settings['template_mail_2']);		
	$tpl->assign("TEMPLATE_MAIL_3", $settings['template_mail_3']);		
	$tpl->assign("TEMPLATE_MAIL_4", $settings['template_mail_4']);		
	$tpl->assign("TEMPLATE_MAIL_5", $settings['template_mail_5']);		
	$tpl->assign("TEMPLATE_MAIL_6", $settings['template_mail_6']);		
	$tpl->assign("TEMPLATE_MAIL_7", $settings['template_mail_7']);		
	$tpl->assign("CHECK_INTERVAL", $settings['check_interval']);		
	$tpl->assign("NUMBER_CHECK", $settings['number_check']);		
	$tpl->assign("NUMBER_CHARS_DESCRIPTION_MIN", $settings['number_chars_description_min']);		
	$tpl->assign("NUMBER_CHARS_DESCRIPTION_MAX", $settings['number_chars_description_max']);		
	$tpl->assign("NUMBER_CHARS_FULLDESCRIPTION_MIN", $settings['number_chars_fulldescription_min']);	
	$tpl->assign("NUMBER_CHARS_FULLDESCRIPTION_MAX", $settings['number_chars_fulldescription_max']);		
	$tpl->assign("NUMBER_HTML_CHARS", $settings['number_html_chars']);		
	$tpl->assign("REQUEST_CAPTCHA", $settings['request_captcha']);		
	$tpl->assign("ADD_LINKS_WITHOUT_CHECK", $settings['add_links_without_check']);		
	$tpl->assign("CHECK_LINKS", $settings['check_links']);		
	$tpl->assign("COMMON_HOST", $settings['common_host']);		
	$tpl->assign("CHECK_GET_PARAMETER", $settings['check_get_parameter']);		
	$tpl->assign("NUMBER_RECIPROCAL_LINKS_LIMIT", $settings['number_reciprocal_links_limit']);		
	$tpl->assign("LIMIT_RECIPROCAL_LINKS", $settings['limit_reciprocal_links']);		
	$tpl->assign("ADD_TO_BLACKLIST", $settings['add_to_blacklist']);		
	$tpl->assign("NEW_LINKS_NOTIFICATION", $settings['new_links_notification']);
		
	//footer
	include "footer.inc";
		
	// Count a quantity of the links
	$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
		
	if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
		
	$total = $result->fetch_assoc();

	// Clear the descriptor
	$result->close();
		
	$tpl->assign("TOTAL_LINKS",$total['COUNT(*)']);	
	$tpl->assign("STR_HELP", STR_HELP);
		
	// print html page
	$tpl->display();	

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("../lib/exception_mysql_debug.inc");
}

?>