<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

// config
require_once 'config/config.inc';

// check install
require_once "lib/check_install.inc";

// Require necessary classes
require_once "class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "lib/function.inc";
	require_once "lib/connect.inc";
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

	$settings = $result->fetch_array();

	$result->close();

	// interface module
	include "templates/language/".$settings['language'].".inc";

	// Check all hidden and new links
	$query = "SELECT * FROM ".DB_LINKS." WHERE status = 'hide'";
	$result = $dbh->query($query);

	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
				
	while($links = $result->fetch_array())
	{
		$date_check = strtotime($links['time_check']);
		$interval_check = ceil((time() - $date_check) / 3600 / 24);
	
		if($links['check_link'] == "yes" AND $interval_check > $settings['check_interval'] AND $interval_check != 1){
			if(check_url_link ($links['reciprocal_link'], $settings['url'])){
				if($settings['add_to_blacklist'] == "yes"){
					$query = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_ABSENSE_RECIPROCAL."' WHERE id_link = ".$links['id_link'];
				}
				else{
					$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$links['id_link'];
				}

				if($dbh->query($query)){
					// Notify the user about his link was removed
					sendmail_del_link($links, STR_SUBJECT_DEL);
				}
			}
			else{
				// Check on, whether the page of answer link for index by metatag <meta name=robot>
				if(check_meta($links['reciprocal_link'])){
					if($settings['add_to_blacklist'] == "yes"){
						$query = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_META."' WHERE id_link = ".$links['id_link'];
					}
					else{
						$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$links['id_link'];
					}

					if($dbh->query($query)){
						// Notify the user about his link was removed
						sendmail_del_link($links, STR_SUBJECT_DEL);
					}
				}
				else{
					// Check on, whether the directory with answer link is closed for index
					if(check_robots($links['reciprocal_link'])){
						if($settings['add_to_blacklist'] == "yes"){
							$query = "UPDATE ".DB_LINKS." SET status = 'black', time = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_ROBOT."' WHERE id_link = ".$links['id_link'];
						}
						else{
							$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$links['id_link'];
						}

						if($dbh->query($query)){
							// Notify the user about his link was removed
							sendmail_del_link($links, STR_SUBJECT_DEL);
						}
					}
					else{
						$update = "UPDATE ".DB_LINKS." SET status = 'show', time_check = NOW(), reason = '', number_check = 0 WHERE id_link = ".$links['id_link'];

						if($dbh->query($update)){
							// Notify the user about his link was restored
							sendMailAdd($links, STR_SUBJECT_ADD);
						}
					}
				}
			}							
		}
			
		$result->close();					
	}	

	// Check all new link
	$query = "SELECT * FROM ".DB_LINKS." WHERE status = 'new'";
	$result = $dbh->query($query);

	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

	while($links = $result->fetch_array())
	{
		$date_check = strtotime($links['time_check']);
		$interval_check = ceil((time() - $date_check) / 3600 / 24);

		$reciprocal_link = $links[reciprocal_link];

		if($links['check_link'] == "yes" AND $interval_check > $settings['check_interval'] AND $interval_check != 1){
			if (check_url_link ($reciprocal_link)){
				$query = "UPDATE ".DB_LINKS." SET status = 'show',
												time_check = NOW()
							WHERE id_link = ".$links['id_link'];

				if ($dbh->query($query)){
				  // Notify the user about his link was added to catalogue
				  sendMailAdd($links, STR_SUBJECT_ADD);
				}
			}
			else{
				if($settings['add_to_blacklist'] == "yes")	{
					$query = "UPDATE ".DB_LINKS." SET status = 'black',
													time = NOW(),
													reason = '".REASON_ABSENSE_RECIPROCAL."'
								  WHERE id_link = ".$links['id_link'];

					$dbh->query($query);
				}
				else{
					$query = "DELETE FROM ".DB_LINKS." WHERE id_link = ".$links['id_link'];
					$dbh->query($query);
				}
			}
		}
	}

	$result->close();

	// Check all other links
	$query = "SELECT * FROM ".DB_LINKS." WHERE status = 'show'";
	$result = $dbh->query($query);
					
	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }
	
	while($links = $result->fetch_array()){
		$date_check = strtotime($links['time_check']);
		$interval_check = ceil((time() - $date_check) / 3600 / 24);
					
		if($links['check_link'] == "yes" AND $interval_check > $settings['check_interval'] AND $interval_check != 1){
			if(check_url_link ($links['reciprocal_link'],$settings['url'])){
				if($links['number_check'] == $settings['number_check']){
					// Form SQL-query to hide link
					$update = "UPDATE ".DB_LINKS." SET status = 'hide', time_check = NOW(), reason = '".REASON_ABSENSE_RECIPROCAL."' WHERE id_link = ".$links['id_link'];

					if($dbh->query($update)){
						// Notify the user about his link was hidded
						$nscript = strpos($_SERVER['REQUEST_URI'], "admin");
						$root = substr($_SERVER['REQUEST_URI'], 0, $nscript);
						$url_link_edit = "".$_SERVER['SERVER_NAME'].$root."edit.php?id=".$links['id_link']."&token=".$links['token']."";

						sendmail_hide_link ($links, $url_link_edit, STR_SUBJECT_HIDE);
					}
				}
				else{
					$update = "UPDATE ".DB_LINKS." SET time_check = NOW(), number_check = number_check + 1 WHERE id_link = ".$links['id_link'];
					$dbh->query($update);										
				}							
			}
			else{
				// Check the page of answer link on index
				if(check_meta($links['reciprocal_link'])){
					if($links['number_check'] == $settings['number_check']){
						// Form SQL-query to hide link
						$update = "UPDATE ".DB_LINKS." SET status = 'hide', time_check = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_ROBOT."' WHERE id_link = ".$links['id_link'];

						if($dbh->query($update)){
							// Notify the user about the link was hidded	
							sendmail_hide_link2($links, MSG_CLOSED_FOR_INDEX_ROBOT, STR_SUBJECT_HIDE);
						}
					}
					else{
						$update = "UPDATE ".DB_LINKS." SET time_check = NOW(), number_check = number_check + 1 WHERE id_link = ".$links['id_link'];
						$dbh->query($update);									
					}
				}
				else{
					// Check the directory is closed for index
					if(check_robots($links['reciprocal_link']))	{
						if($links['number_check'] == $settings['number_check']){
							// Form SQL-query to hide link
							$update = "UPDATE ".DB_LINKS." SET status = 'hide', time_check = NOW(), reason = '".REASON_CLOSED_FOR_INDEX_ROBOT."' WHERE id_link = ".$links['id_link'];

							if($dbh->query($update)){
								// Notify the user about his link was hidded
								$reason = MSG_CLOSED_FOR_INDEX_ROBOT;

								sendmail_hide_link2($links, $reason, STR_SUBJECT_HIDE);
							}
						}else{
							$update = "UPDATE ".DB_LINKS." SET time_check = NOW(), number_check = number_check + 1 WHERE id_link = ".$links['id_link'];
							$dbh->query($update);
						}
					}
					else{
						$update = "UPDATE ".DB_LINKS." SET time_check = NOW(), reason = '', number_check = 0 WHERE id_link = ".$links['id_link'];
						$dbh->query($update);
					}
				}
			}
		}
	}				
			
	$result->close();

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("lib/exception_mysql_debug.inc");
}

?>