<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

// config
require_once 'config/config.inc';

// check install
require_once "lib/check_install.inc";

// Require necessary classes
require_once "class/class.exception_mysql.php";

try
{
	// Require necessary libs
	require_once "lib/function.inc";
	require_once "lib/connect.inc";
	
	// Shield a special characters
	$_GET["url"] = strtolower($dbh->real_escape_string(trim($_GET["url"])));

	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

	$settings = $result->fetch_array();

	$result->close();

	// interface module
	include "templates/language/".$settings['language'].".inc";

	if($_GET["url"]){
		// Check whether catalogue has this url
		$url = urldecode($_GET["url"]);

		if(substr($url, 0, 4) == "www.") { $url = str_replace('www.','',$url); }
		if(substr($url, 0, 7) == "http://") { $url = str_replace('http://','',$url); }
		if(strpos($url,'/')>0) list($url) = explode('/',$url);

		$src_url = str_replace('.','\\.',$url);

		$query = "SELECT * FROM ".DB_LINKS." WHERE url RLIKE '^(www\\.)?".$src_url."$' AND status = 'show' OR
													url RLIKE '^(www\\.)?".$src_url."$' AND status = 'black'";

		$result = $dbh->query($query);

		if (!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

		if ($result->num_rows > 0){
			echo MSG_ERROR_EXIST_SITE;
		}

		$result->close();

		$query = "SELECT * FROM ".DB_LINKS." WHERE url RLIKE '^(www\\.)?".$src_url."$' AND status = 'new' OR
													url RLIKE '^(www\\.)?".$src_url."$' AND status = 'hide'";

		$result = $dbh->query($query);

		if (!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

		if ($result->num_rows > 0){
			echo MSG_ERROR_AWAIT_CHECK;
		}

		$result->close();

		// Check url on valid
		if (check_url($url)){
			echo MSG_ERROR_WRONG_URL;
		}

		if (native_check_url($url, $_SERVER["SERVER_NAME"])){
			echo MSG_ERROR_VERIFY_DOMEN;
		}
	}

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("lib/exception_mysql_debug.inc");
}

?>
