<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

// config
require_once 'config/config.inc';

// check install
require_once "lib/check_install.inc";

// Check an input data
if(!preg_match("|^[\d]*$|",$_POST['id_link'])) exit();
if(!preg_match("|^[\d]*$|",$_GET['id'])) exit();

// Start a new session
session_start();

// Require necessary classes
require_once "class/class.exception_mysql.php";
require_once 'class/html_template/SeparateTemplate.php';

try
{
	// Require necessary libs
	require_once "lib/function.inc";
	require_once "lib/connect.inc";	
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

	$settings = $result->fetch_array();

	$result->close();

	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";

	$error = Array();

	$action = "";
	$action = $_POST["action"];

	if(!empty($action)){
		$_POST["reciprocal_link"] = trim($_POST["reciprocal_link"]);

		// Shield a special characters
		$_POST['reciprocal_link'] = $dbh->real_escape_string($_POST['reciprocal_link']);
		$_POST['url'] = $dbh->real_escape_string($_POST['url']);
		$_POST['id_link'] = $dbh->real_escape_string($_POST['id_link']);
		$_POST['token'] = $dbh->real_escape_string($_POST['token']);		

		// Cut http:// from the url of site
		if(!empty($_POST["reciprocal_link"])){
			if((substr($_POST['reciprocal_link'], 0, 7)) == "http://") { $_POST['reciprocal_link'] = str_replace('http://','',$_POST['reciprocal_link']); }
		}
		
		// If $settings['check_links'] == yes,
		// then find the link on our site. If there is non any link on our site print error
		if((!empty($_POST["reciprocal_link"]) and $settings['check_links'] == "yes") and check_url_link ($_POST['reciprocal_link'])){
			$action = "";
			$error[] = MSG_ERROR_NOT_RECIPROCAL_LINK;
		}

		// Check url address of reciprocal link, if it has url address of catalogue in arg=value then print error
		if((!empty($_POST["reciprocal_link"]) and $settings['check_get_parameter'] == "yes") and check_get_parameter ($_POST['reciprocal_link'])){
			$action = "";
			$error[] = MSG_ERROR_ARG_VALUE;
		}

		// Verify domen of reciprocal link and of catalogue
		if(!empty($_POST["reciprocal_link"]) and native_check_link($_POST['reciprocal_link'],$_POST['url'])){
			$action = "";
			$error[] = MSG_ERROR_VERIFY_DOMEN;
		}

		// Check value of reciprocal_link, if empty then print error
		if(empty($_POST["reciprocal_link"])){
			$action = "";
			$error[] = MSG_ERROR_NOT_FILLED_RECIPROCAL_LINK;
		}		
		
		// Check key of link
		$query = "SELECT token FROM ".DB_LINKS." WHERE id_link = ".$_POST['id_link'];
		$result = $dbh->query($query);

		if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

		$key = $result->fetch_array();

		// Clear the descriptor
		$result->close();		

		if($key['token'] != $_POST['token']){
			error(MSG_ERROR_EDITLINK);
		}

		// Form the SQL query on edit if not any errors
		if(count($error) == 0){
			$update = "UPDATE ".DB_LINKS." SET reciprocal_link = '".$_POST['reciprocal_link']."',
												status = 'show',
												number_check = 0,
												time_check = NOW(),
												reason = ''
						WHERE id_link = ".$_POST['id_link'];

			if($dbh->query($update)){
				
				include "nulltop.php";
				
				echo MSG_CHANGE_HAS_ADDED;
				
				include "nullbottom.php";
				
				exit();
			}
			else{
				throw new ExceptionMySQL($dbh->error,$update,"Error executing SQL query!");
			}
		}		
	}

	if(empty($action)){
		if(empty($_GET['id'])){
			error(MSG_ERROR_EDITLINK);
		}

		if(empty($_GET['token'])){
			error(MSG_ERROR_EDITLINK);
		}
	
		$_GET['token'] = $dbh->real_escape_string($_GET['token']);		

		// Get a link's data
		$query = "SELECT * FROM ".DB_LINKS." WHERE id_link = ".$_GET['id'];
		$result = $dbh->query($query);

		if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

		$links = $result->fetch_array();

		$result->close();
		
		$reciprocal_link = $_POST['reciprocal_link'] ? $_POST['reciprocal_link'] : $links['reciprocal_link'];

		if($links['token'] == $_GET['token']){
			// templates
			$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/edit.tpl");

			// Header
			$tpl->assign('TITLE', $title);
			$tpl->assign('DESCRIPTION', $description);
			$tpl->assign('KEYWORDS', $keywords);
			$tpl->assign('VERSION', $version);
		
			//form
			$tpl->assign('STR_GO_BACK', STR_GO_BACK);
			$tpl->assign('ACTION', $_SERVER['REQUEST_URI']);		
			$tpl->assign('STR_RECIPROCAL_LINK', STR_RECIPROCAL_LINK);		
			$tpl->assign('RECIPROCAL_LINK', $reciprocal_link);		
			$tpl->assign('TOKEN', $links['token']);		
			$tpl->assign('URL', $links['url']);	
			$tpl->assign('ID_LINK', $links['id_link']);
			$tpl->assign('BUTTON_EDIT', BUTTON_EDIT);			

			//errors
			if(count($error) > 0){
				$errorBlock = $tpl->fetch('show_errors');		
				$errorBlock->assign('STR_IDENTIFIED_FOLLOWING_ERRORS', STR_IDENTIFIED_FOLLOWING_ERRORS);
		
				foreach($error as $row){
					$rowBlock = $errorBlock->fetch('row');
					$rowBlock->assign('ERROR', $row);
					$errorBlock->assign('row', $rowBlock);
				}
		
				$tpl->assign('show_errors', $errorBlock);
			}			

			// footer
			$tpl->assign("STR_LOGO", STR_LOGO);
			$tpl->assign("STR_AUTHOR", STR_AUTHOR);

			// print html page
			$tpl->display();
		}
		else{
			// print error if there is an error
			error(MSG_ERROR_EDITLINK);
		}
	}

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("lib/exception_mysql_debug.inc");
}

?>
