<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

// config
require_once 'config/config.inc';

// check install
require_once "lib/check_install.inc";

// Require necessary classes
require_once "class/class.exception_mysql.php";
require_once 'class/html_template/SeparateTemplate.php';

try
{
	// Require necessary libs
	require_once "lib/function.inc";
	require_once "lib/connect.inc";	
	
	// Get the Settings
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	$settings = $result->fetch_array();

	// Clear the descriptor
	$result->close();

	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";
	
	// include template
	$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/help.tpl");

	//header
	$tpl->assign('METATITLE', 'Help');
	$tpl->assign('METADESCRIPTION', '');
	$tpl->assign('METAKEYWORDS', '');
	$tpl->assign('VERSION', $version);

	// content
	$tpl->assign('HELP', HELP);

	// footer
	$tpl->assign('STR_LOGO', STR_LOGO);
	$tpl->assign('STR_AUTHOR', STR_AUTHOR);

	// print html page
	$tpl->display();

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("lib/exception_mysql_debug.inc");
}

?>
