<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

// config
require_once 'config/config.inc';

// check install
require_once "lib/check_install.inc";

// Require necessary classes
require_once "class/class.exception_mysql.php";
require_once 'class/html_template/SeparateTemplate.php';

try
{
	// Require necessary libs
	require_once "lib/function.inc";
	require_once "lib/connect.inc";	
	
	// Shield a special characters
	$_GET['search'] = $dbh->real_escape_string($_GET['search']);
	$_GET['id_cat'] = $dbh->real_escape_string($_GET['id_cat']);
	$_GET['logic'] = $dbh->real_escape_string($_GET['logic']);
	$_GET['url'] = $dbh->real_escape_string($_GET['url']);
	$_GET['id_catalog'] = $dbh->real_escape_string($_GET['id_catalog']);
	
	// Get a settings of catalogue
	$query = "SELECT * FROM ".DB_SETTING."";
	$result = $dbh->query($query);

	if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

	$settings = $result->fetch_array();
	$result->close();

	// interface modules, the description of pages and meta tags
	include "templates/language/".$settings['language'].".inc";

	$order = $settings['view_order'] == 1 ? "time" : "count";
	$desc = $settings['order_link'] == 1 ? "" : "DESC";
	
	if($_GET['id_cat']){
		$arraypathway = Array();
		$arraypathway = topbarmenu($_GET['id_cat'],'');	
	
		if($settings['static'] == 1)
			$pathway = '<a href="index.html">'.STR_HOME.'</a> ';
		else 
			$pathway = '<a href="index.php">'.STR_HOME.'</a> '; 	

		for($i = 0; $i<count($arraypathway); $i++)
		{
			if($settings['static'] == 1) 
				$pathway .= '» <a href="'.root().'page_'.$arraypathway[$i][0].'_1.html">'.$arraypathway[$i][1].'</a>';
			else 
				$pathway .= '» <a href="http://'.$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF'].'?id_cat='.$arraypathway[$i][0].'">'.$arraypathway[$i][1].'</a>';
		}	
	}
			
	if(!empty($_GET['id_link'])){
		// include template
		$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/info.tpl");

		$query = "SELECT *,c.name AS catname, l.description AS description, l.keywords AS keywords FROM ".DB_LINKS." l LEFT JOIN ".DB_CATALOG." c ON l.id_cat = c.id_cat WHERE status = 'show' AND id_link = ".$_GET['id_link'];
		$result = $dbh->query($query);

		if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

		$links = $result->fetch_array();
		$result->close();

		$description = $links['description'];
		$keywords = $links['keywords'];
		$title = "".TITLEPAGE." ".$version." - ".$links['catname'];

		if(empty($title)) { $title = "".TITLEPAGE." ".$version; }
		if(empty($keywords)) { $keywords = ""; }
		if(empty($description)) { $description = DESCRIPTIONPAGE; }

		//header
		$tpl->assign('METATITLE', $title);
		$tpl->assign('METADESCRIPTION', $description);
		$tpl->assign('METAKEYWORDS', $keywords);
		$tpl->assign('VERSION', $version);
		
		if($settings['static'] == 1){
			$link_go_back = "".root()."page_".$links['id_cat']."_1.html";
		}
		else{
			$link_go_back = "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']."?id_cat=".$links['id_cat'];
		}		
		
		$url_to_site = "".$_SERVER['PHP_SELF']."?id_link=".$links['id_link']."&url=".$links['url']."";
		$links['full_description'] = preg_replace("/\\r\\n/s","<br />", $links['full_description']);
		
		$tpl->assign('CATNAME', $links['catname']);
		$tpl->assign('URL_TO_SITE', $url_to_site);
		$tpl->assign('GO_BACK', $link_go_back);

		$tpl->assign('URL', $links['url']);
		$tpl->assign('NAME', $links['name']);
		$tpl->assign('FULL_DESCRIPTION', $links['full_description']);
		
		$tpl->assign('STR_GO_TO_WEBSITE', STR_GO_TO_WEBSITE);
		$tpl->assign('STR_GO_BACK', STR_GO_BACK);		
		
		$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE status = 'show'";
		$result = $dbh->query($query);
		
		if(!$result) throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!");
		
		$total = $result->fetch_assoc();

		// Clear the descriptor
		$result->close();		
		
		if($total['COUNT(*)'] > 3){
			$tpl->assign('INT', 'show');
		}

		if($_GET['url']){
			// If there is a URL then count one click
			$update = "UPDATE ".DB_LINKS." SET count = count + 1 WHERE id_link = ".$_GET['id_link'];

			if($dbh->query($update)){
				// Make a redirect
				$tpl->assign('REDIRECT_URL', $links['url']);
			}
		}
		
		$tpl->assign('STR_LOGO', STR_LOGO);
		$tpl->assign('STR_AUTHOR', STR_AUTHOR);

		// print html page
		$tpl->display();
	}
	else{
		// include template
		$tpl = SeparateTemplate::instance()->loadSourceFromFile("templates/index.tpl");

		if(!empty($_GET['id_cat']) and $_GET['id_cat'] != 0){
			// Get the meta tags of catalogue
			$query = "SELECT description,keywords,name FROM ".DB_CATALOG." WHERE id_cat = ".$_GET['id_cat'];
			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

			$row		 = $result->fetch_assoc();
			$description = $row['description'];
			$keywords	 = $row['keywords'];
			$title		 = "".TITLEPAGE." ".$version." - ".$row['name'];

			$result->close();
		}

		if(empty($title)) { $title = "".TITLEPAGE." ".$version.""; }
		if(empty($keywords)) { $keywords = ""; }
		if(empty($description)) { $description = DESCRIPTIONPAGE; }		
		
		//header
		$tpl->assign('METATITLE', $title);
		$tpl->assign('METADESCRIPTION', $description);
		$tpl->assign('METAKEYWORDS', $keywords);
		$tpl->assign('VERSION', $version);

		$search = stripslashes(trim(urldecode($_GET['search'])));

		// Elements of the pagination
		$all_number_links = $settings['all_number_links'] ? $settings['all_number_links'] : 5;	

		$page = $_GET['page'];

		if(empty($page)) $page = 1;
		$begin = ($page - 1) * $all_number_links;
		
		$id_cat = $_GET['id_cat'] ? $_GET['id_cat'] : 0;
		
		$query = "SELECT * FROM ".DB_CATALOG." WHERE id_parent = ".$id_cat." ORDER BY name";
		$result = $dbh->query($query);

		if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

		while($row = $result->fetch_array())
		{
			$arraycat[] = array($row['name'], $row['id_cat']); 
		}

		$result->close();

		$total = count($arraycat);

		$number = (int)($total / $settings['columns_number']);
		if((float)($total / $settings['columns_number']) - $number != 0) $number++;

		// Form an array
		for($i = 0; $i < $number; $i++){
			for($j = 0; $j < $settings['columns_number']; $j++){
				$arr[$i][$j] = $arraycat[$j * $number + $i];
			}
		}

		$rowPrintCat = $tpl->fetch('PRINT_CAT');
		
		for($i = 0; $i < $number; $i++){
		
			$rowBlockCat = $rowPrintCat->fetch('ROW_CAT');	

			for($j = 0; $j < $settings['columns_number']; $j++){
			
				$rowBlockFolder = $rowBlockCat->fetch('ROW_FOLDER');	
			
				if($arr[$i][$j][0]){
					if($settings['static'] == 1) 
						$rowBlockFolder->assign('FOLDER_LINK', "".root()."page_".$arr[$i][$j][1]."_1.html");
					else 
						$rowBlockFolder->assign('FOLDER_LINK', "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']."?id_cat=".$arr[$i][$j][1]);
						
					$query = "SELECT * FROM ".DB_CATALOG." WHERE image != '' and id_cat = ".$arr[$i][$j][1];
					$result = $dbh->query($query);

					if(!$result) { throw new ExceptionMySQL($dbh->error, $query, "Error executing SQL query!"); }					
	
					if($result->num_rows > 0)
						$rowBlockFolder->assign('IMAGEFOLDER', "img.php?id_cat=".$arr[$i][$j][1]);
					else
						$rowBlockFolder->assign('IMAGEFOLDER', 'images/folder.gif');

					$columns_number = (int)(100 / $settings['columns_number']);
					$rowBlockFolder->assign('COLUMNS_NUMBER', $columns_number);	
					$rowBlockFolder->assign('FOLDER_LINK_NAME', $arr[$i][$j][0]);
					$rowBlockFolder->assign('NUMBERSLINKS', ShowNumbersLinks($arr[$i][$j][1],0));
					$rowBlockFolder->assign('SHOWSUBCAT', ShowSubCat($arr[$i][$j][1],$settings['static'],5));
						
					$rowBlockCat->assign('ROW_FOLDER', $rowBlockFolder);
					
					$result->close();					
				}
			}

			$rowPrintCat->assign('ROW_CAT', $rowBlockCat);
		}
	
		$tpl->assign('PRINT_CAT', $rowPrintCat);
		$tpl->assign('TOPBARMENU', $pathway);	
		$tpl->assign('SUBCATALOG', STR_NEW_LINKS);		
		
		//searchform
		$tpl->assign('STR_KEYWORDS_SEARCHFORM', STR_KEYWORDS_SEARCHFORM);
		$tpl->assign('STR_KEYWORDS', STR_KEYWORDS);
		$tpl->assign('STR_SEARCH_IN_CATALOG_SEARCHFORM', STR_SEARCH_IN_CATALOG_SEARCHFORM);
		$tpl->assign('STR_IT_DOESNT_MATTER_SEARCHFORM', STR_IT_DOESNT_MATTER_SEARCHFORM);
		$tpl->assign('STR_MEETING_OF_KEYWORDS_SEARCHFORM', STR_MEETING_OF_KEYWORDS_SEARCHFORM);
		$tpl->assign('STR_AT_LEAST_ONCE', STR_AT_LEAST_ONCE);
		$tpl->assign('STR_ALL_WORDS_TOGETHER', STR_ALL_WORDS_TOGETHER);
		$tpl->assign('BUTTON_FIND', BUTTON_FIND);
		$tpl->assign('ACTION', $_SERVER['PHP_SELF']);
		$tpl->assign('SEARCH', urldecode($_GET['search']));
		$tpl->assign('ID_CATALOG', $_GET['id_catalog']);
		$tpl->assign('LOGIC', $_GET['logic']);
		$tpl->assign('OPTION', ShowCatalogList(0, 0));
		
		$tpl->assign('STR_ADD_URL', STR_ADD_URL);		

		if(empty($_GET['id_cat']) AND empty($_GET['search']) AND empty($_GET['id_link'])){
			
			// Print a last added links
			$query = "SELECT *, c.name AS catname, l.description AS description, l.keywords AS keywords, l.name AS name FROM ".DB_LINKS." l LEFT JOIN ".DB_CATALOG." c ON l.id_cat = c.id_cat
						WHERE status = 'show'
						ORDER BY time DESC
						LIMIT ".$settings['all_number_links'];

			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

			if($result->num_rows > 0){

				while($row = $result->fetch_array())
				{
					if($settings['static'] == 1){
						if($_GET['page']) 
							$read_more = "".root()."link_".$row['id_link']."_".$_GET['page'].".html"; 
						else 
							$read_more = "".root()."link_".$row['id_link'].".html";
					}
					else{
						if($_GET['page'])
							$read_more = "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']."?id_link=".$row['id_link']."&page=".$_GET['page']; 
						else
							$read_more = "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']."?id_link=".$row['id_link']; 
					}				

					if(!empty($links['htmlcode_banner'])) 
						$htmlcode_banner = $links['htmlcode_banner']; 
					else 
						$htmlcode_banner = '<a href=http://'.$row['url'].' target=_blank><img border="0" width="88" height="31" src="images/noimage.gif"></a>';

					$row['description_link'] = nl2br($row['description_link']);						
						
					$rowBlock = $tpl->fetch('ROW_LINKS');	

					$rowBlock->assign('STR_ADDED', STR_ADDED);
					$rowBlock->assign('STR_CATEGORY', STR_CATEGORY);
					$rowBlock->assign('STR_NUMBER_OF_CLICKS', STR_NUMBER_OF_CLICKS);
					$rowBlock->assign('STR_READ_MORE', STR_READ_MORE);
					
					$rowBlock->assign('URL', $row['url']);				
					$rowBlock->assign('NAME', $row['name']);
					$rowBlock->assign('DESCRIPTION', $row['description']);				
					$rowBlock->assign('READ_MORE', $read_more);				
					$rowBlock->assign('HTMLCODE_BANNER', $htmlcode_banner);						
					$rowBlock->assign('TIME', $row['time']);
					$rowBlock->assign('CATEGORY', $row['catname']);
					$rowBlock->assign('NUMBER_OF_CLICKS', $row['count']);
					$rowBlock->assign('SHOW_PR', $settings['show_cy']);
					$rowBlock->assign('SHOW_CY', $settings['show_pr']);
					
					$tpl->assign('ROW_LINKS', $rowBlock);				
				}
			}
			else{
				// if there are not any links then print the message
				$tpl->assign('MSG_NOTLINKS', MSG_NOTLINKS);				
			}
		}

		if(!empty($_GET['id_cat']) AND empty($_GET['search'])){		
			// Get the name of catalogue
			$query = "SELECT name FROM ".DB_CATALOG." WHERE id_cat = ".$_GET['id_cat'];
			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

			$catalog = $result->fetch_array();

			// Clear the descriptor
			$result->close();

			$on_main_page = $settings['static'] == 1 ? "index.html" : "index.php";
			
			// Print links
			$query = "SELECT *,l.name AS name, c.name AS catname, l.description AS description FROM ".DB_LINKS." l
						LEFT JOIN ".DB_CATALOG." c ON l.id_cat = c.id_cat
						WHERE l.id_cat = ".$_GET['id_cat']." AND status = 'show'
						ORDER BY ".$order." ".$desc."
						LIMIT ".$begin.", ".$all_number_links."";

			$result = $dbh->query($query);

			if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

			if($result->num_rows > 0){
				while($row = $result->fetch_array())
				{
					if($settings['static'] == 1){
						if($_GET['page']) 
							$read_more = "".root()."link_".$row['id_link']."_".$_GET['page'].".html"; 
						else 
							$read_more = "".root()."link_".$row['id_link'].".html"; 
					}
					else{
						if($_GET['page']) 
							$read_more = "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']."?id_link=".$row['id_link']."&page=".$_GET['page']; 
						else 
							$read_more = "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']."?id_link=".$row['id_link']; 
					}					

					// print links
					if(!empty($links['htmlcode_banner'])) 
						$htmlcode_banner = $links['htmlcode_banner']; 
					else 
						$htmlcode_banner = '<a href=http://'.$row['url'].' target=_blank><img border="0" width="88" height="31" src="images/noimage.gif"></a>';

					$row['description_link'] = nl2br($row['description_link']);						
						
					$rowBlock = $tpl->fetch('ROW_LINKS');	

					$rowBlock->assign('STR_ADDED', STR_ADDED);
					$rowBlock->assign('STR_CATEGORY', STR_CATEGORY);
					$rowBlock->assign('STR_NUMBER_OF_CLICKS', STR_NUMBER_OF_CLICKS);
					$rowBlock->assign('STR_READ_MORE', STR_READ_MORE);
					
					$rowBlock->assign('URL', $row['url']);				
					$rowBlock->assign('NAME', $row['name']);
					$rowBlock->assign('DESCRIPTION', $row['description']);				
					$rowBlock->assign('READ_MORE', $read_more);				
					$rowBlock->assign('HTMLCODE_BANNER', $htmlcode_banner);						
					$rowBlock->assign('TIME', $row['time']);
					$rowBlock->assign('CATEGORY', $row['catname']);
					$rowBlock->assign('NUMBER_OF_CLICKS', $row['count']);
					$rowBlock->assign('SHOW_PR', $settings['show_cy']);
					$rowBlock->assign('SHOW_CY', $settings['show_pr']);				
					$tpl->assign('ROW_LINKS', $rowBlock);				
				}

				$result->close();

				// Print the pagination
				$query = "SELECT COUNT(*) FROM ".DB_LINKS." WHERE id_cat = ".$_GET['id_cat']." AND status = 'show'";
				$result = $dbh->query($query);

				if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

				$total = $result->fetch_assoc();

				$result->close();

				$number = intval(($total['COUNT(*)'] - 1) / $all_number_links) + 1;

				// Define the view of url links
				if($settings['static'] == 1){
					if($page != 1) $pervpage = '<a href='.root().'page_'.$_GET['id_cat'].'_1.html>&lt;&lt; </a> <a href='.root().'page_'.$_GET['id_cat'].'_'.($page - 1).'.html>&lt; </a>';
					if($page != $number) $nextpage = '<a href='.root().'page_'.$_GET['id_cat'].'_'.($page + 1).'.html> &gt;</a> <a href='.root().'page_'.$_GET['id_cat'].'_'.$number.'.html> &gt;&gt;</a>';

					// Form the links of pagination
					if($page - 2 > 0) $page2left = '<a href='.root().'page_'.$_GET['id_cat'].'_'.($page - 2).'.html>...'.($page - 2).'</a> | ';
					if($page - 1 > 0) $page1left = '<a href='.root().'page_'.$_GET['id_cat'].'_'.($page - 1).'.html>'.($page - 1) .'</a> | ';
					if($page + 2 <= $number) $page2right = ' | <a href='.root().'page_'.$_GET['id_cat'].'_'.($page + 2).'.html>'.($page + 2).'...</a>';
					if($page + 1 <= $number) $page1right = ' | <a href='.root().'page_'.$_GET['id_cat'].'_'.($page + 1).'.html>'.($page + 1).'</a>';
				}
				else{
					if($page != 1) $pervpage = '<a href='.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page=1>&lt;&lt; </a> <a href='.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page - 1).'>&lt; </a> ';
					if($page != $number) $nextpage = '<a href='.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page + 1).'> &gt;</a> <a href='.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.$number.'> &gt;&gt;</a>';

					// Form the links of pagination
					if($page - 2 > 0) $page2left = ' <a href='.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page - 2).'>...'.($page - 2).'</a> | ';
					if($page - 1 > 0) $page1left = ' <a href='.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page - 1).'>'.($page - 1).'</a> | ';
					if($page + 2 <= $number) $page2right = ' | <a href='.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page + 2).'>'.($page + 2).'...</a>';
					if($page + 1 <= $number) $page1right = ' | <a href='.$_SERVER['PHP_SELF'].'?id_cat='.$_GET['id_cat'].'&page='.($page + 1).'>'.($page + 1).'</a>';
				}
				
				// print a pagination
				if($number > 1){
					$blockPagination = $tpl->fetch('pagination');	
					$blockPagination->assign('STR_PAGES', STR_PAGES);			
					$blockPagination->assign('PERVPAGE', $pervpage);			
					$blockPagination->assign('PAGE2LEFT', $page2left);			
					$blockPagination->assign('PAGE1LEFT', $page1left);			
					$blockPagination->assign('PAGE', $page);			
					$blockPagination->assign('PAGE1RIGHT', $page1right);			
					$blockPagination->assign('PAGE2RIGHT', $page2right);			
					$blockPagination->assign('NEXTPAGE', $nextpage);
			
					$tpl->assign('pagination', $blockPagination);			
				}
			}
			else{
				// if there are not any links then print the notice
				$tpl->assign('MSG_NOTLINKS',MSG_NOTLINKS);
			}
		}

		// The result of search
		if(!empty($_GET['search'])){
			if(strlen($search) >= 3){
				$temp = strtok($search," ");
				$temp = "$temp*";
				
				$logstr = $_GET['logic'] == 1 ? "and" : "or";

				if($_GET['id_catalog'] == 0) 
					$tmp2 = "AND status = 'show'";
				else 
					$tmp2 = "AND status = 'show' AND l.id_cat = ".$_GET['id_catalog'];

				while ($temp)
				{
					if($is_query) 
						$tmp1 .= " $logstr MATCH (l.name,l.description,url,full_description,email,l.keywords) AGAINST ('$temp' IN BOOLEAN MODE) $tmp2";
					else 
						$tmp1 .= "MATCH (l.name,l.description,url,full_description,email,l.keywords) AGAINST ('$temp' IN BOOLEAN MODE) $tmp2";
					
					$is_query = true;
					$temp = strtok(" ");
				}

				// Make a search in the DB
				$query = "SELECT *, l.name AS name, c.name AS catname, l.description AS description, l.keywords AS keywords FROM ".DB_LINKS." l
							LEFT JOIN ".DB_CATALOG." c ON l.id_cat = c.id_cat
							WHERE ".$tmp1."
							GROUP BY id_link
							ORDER BY ".$order." ".$desc."
							LIMIT ".$begin.", ".$all_number_links."";

				$result = $dbh->query($query);

				if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

				if($result->num_rows > 0){
					while($row = $result->fetch_array())
					{
						if($settings['static'] == 1){
							if($_GET['page']) 
								$read_more = "".root()."link_".$row['id_link']."_".$_GET['page'].".html"; 
							else 
								$read_more = "".root()."link_".$row['id_link'].".html"; 
						}
						else{
							if($_GET['page']) 
								$read_more = "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']."?id_link=".$row['id_link']."&page=".$_GET['page']; 
							else 
								$read_more = "http://".$_SERVER['SERVER_NAME'].$_SERVER['PHP_SELF']."?id_link=".$row['id_link']; 
						}						

						if(!empty($row['htmlcode_banner'])) 
							$htmlcode_banner = $row['htmlcode_banner']; 
						else 
							$htmlcode_banner = '<a href=http://'.$row['url'].' target=_blank><img border="0" width="88" height="31" src="images/noimage.gif"></a>';

						$row['description_link'] = nl2br($row['description_link']);						
						
						$rowBlock = $tpl->fetch('ROW_LINKS');	

						$rowBlock->assign('STR_ADDED', STR_ADDED);
						$rowBlock->assign('STR_CATEGORY', STR_CATEGORY);
						$rowBlock->assign('STR_NUMBER_OF_CLICKS', STR_NUMBER_OF_CLICKS);
						$rowBlock->assign('STR_READ_MORE', STR_READ_MORE);
						
						$rowBlock->assign('URL', $row['url']);				
						$rowBlock->assign('NAME', $row['name']);
						$rowBlock->assign('DESCRIPTION', $row['description']);				
						$rowBlock->assign('READ_MORE', $read_more);				
						$rowBlock->assign('HTMLCODE_BANNER', $htmlcode_banner);						
						$rowBlock->assign('TIME', $row['time']);
						$rowBlock->assign('CATEGORY', $row['catname']);
						$rowBlock->assign('NUMBER_OF_CLICKS', $row['count']);
						$rowBlock->assign('SHOW_PR', $settings['show_cy']);
						$rowBlock->assign('SHOW_CY', $settings['show_pr']);				
						$tpl->assign('ROW_LINKS', $rowBlock);	
					}

					$result->close();

					// The pagination of a search result
					$query = "SELECT COUNT(*) FROM ".DB_LINKS." l LEFT JOIN ".DB_CATALOG." c ON l.id_cat = c.id_cat WHERE ".$tmp1."";
					$result = $dbh->query($query);

					if(!$result) { throw new ExceptionMySQL($dbh->error,$query,"Error executing SQL query!"); }

					$total = $result->fetch_assoc();

					$result->close();

					$number = intval(($total['COUNT(*)'] - 1) / $all_number_links) + 1;

					if($page != 1) $pervpage = '<a href='.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page=1>&lt;&lt; </a> <a href='.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page - 1).'>&lt; </a> ';
					if($page != $number) $nextpage = '<a href='.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page + 1).'> &gt;</a> <a href='.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.$number.'> &gt;&gt;</a>';

					// Form the links of pagination
					if($page - 2 > 0) $page2left = '<a href='.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page - 2).'>...'.($page - 2).'</a> | ';
					if($page - 1 > 0) $page1left = '<a href='.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page - 1).'>'.($page - 1) .'</a> | ';
					if($page + 2 <= $number) $page2right = ' | <a href='.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page + 2).'>'.($page + 2).'...</a>';
					if($page + 1 <= $number) $page1right = ' | <a href='.$_SERVER['PHP_SELF'].'?search='.urlencode($_GET['search']).'&id_catalog='.$_GET['id_catalog'].'&logic='.$_GET['logic'].'&page='.($page + 1).'>'.($page + 1).'</a>';

					// print a pagination
					if($number > 1){
						$blockPagination = $tpl->fetch('pagination');	
						$blockPagination->assign('STR_PAGES', STR_PAGES);			
						$blockPagination->assign('PERVPAGE', $pervpage);			
						$blockPagination->assign('PAGE2LEFT', $page2left);			
						$blockPagination->assign('PAGE1LEFT', $page1left);			
						$blockPagination->assign('PAGE', $page);			
						$blockPagination->assign('PAGE1RIGHT', $page1right);			
						$blockPagination->assign('PAGE2RIGHT', $page2right);			
						$blockPagination->assign('NEXTPAGE', $nextpage);
			
						$tpl->assign('pagination', $blockPagination);			
					}
				}
				else{
					// if no results of search print the notice
					$tpl->assign('MSG_SEARCH_NOTFOUND', MSG_SEARCH_NOTFOUND);
				}
			}
			else{
				$tpl->assign('MSG_SEARCH_QUANTITY_CHARCTER', MSG_SEARCH_QUANTITY_CHARCTER);
			}
		}

		// footer
		$tpl->assign("STR_LOGO", STR_LOGO);
		$tpl->assign("STR_AUTHOR", STR_AUTHOR);

		// print html page
		$tpl->display();
	}

	$dbh->close();
}
catch(ExceptionMySQL $exc)
{
	require_once("lib/exception_mysql_debug.inc");
}

?>