<?php

/********************************************
* My Links Manager 2.0.4
* Copyright (c) 2011-2015 Alexander Yanitsky
* Website: http://janicky.com
* E-mail: janickiy@mail.ru
* Skype: janickiy
********************************************/

require_once 'config/config.inc';

// Require necessary libs
require_once "lib/function.inc";
require_once "lib/connect.inc";	

// Settings
$security_image_type = 'GIF';	// Possible formats: GIF, JPEG, PNG
$security_width = 130;			 // Image Width
$security_height = 50;			 // Image Height
$security_num_letter = 4;		 // Number of characters you can enter
$path_fonts = './fonts/';		 // path to fonts

// Get the the identifier of session
if($_GET['sid']){
	$_GET['sid'] = $dbh->real_escape_string($_GET['sid']);	

	$sid = $_GET['sid'];

	// The necessary parameters for the  creation
	$security_font_size = intval($security_height / (($security_height / $security_width) * 8));
	$code = array();
	$letters = range(0,9);

	// Create empty image
	$src = imagecreatetruecolor($security_width,$security_height);

	// Fill backgraund
	$fon = imagecolorallocate($src,255,255,255);
	imagefill($src,0,0,$fon);

	// Upload fonts
	$fonts = array();
	$dir = opendir($path_fonts);

	while($fontName = readdir($dir))
	{
		if($fontName != "." && $fontName != ".."){
			if(strtolower(strrchr($fontName,'.')) == '.ttf') $fonts[] = $path_fonts.$fontName;
		}
	}

	closedir($dir);

	// If the fonts exist
	if(sizeof($fonts) > 0){
		unset($x,$y);
		unset($x1,$y2);

		// Fill main letters if folder of fonts is not empty
		for($i = 0; $i<$security_num_letter; $i++){
			// reference point
			$h = 1;

			// Create code
			$color = imagecolorallocatealpha($src,rand(0,180),rand(0,180),rand(0,180),rand(10,30));
			$font = $fonts[rand(0,sizeof($fonts) - 1)];
			$letter = $letters[rand(0,sizeof($letters) - 1)];
			$size = rand($security_font_size * 1.8 - 0.5,$security_font_size * 1.8 + 0.5);

			if(empty($x)){
				$x = $security_width * 0.16;
			}
			else{
				$x = $x + ($security_width * 0.8) / $security_num_letter + rand(0,$security_width * 0.01);
			}

			if($h == rand(8,10)){
				$y = (($security_height*1.3 * 3) / 5) + rand(0,$security_height * 0.02);
			}
			else{
				$y = (($security_height*1.3 * 3) / 5) - rand(0,$security_height * 0.02);
			}

			$angle = rand(5,40);

			// remember it
			$code[] = $letter;

			if($h == rand(0,10)) $letter = strtoupper($letter);
			if($h == rand(1,2)) $angle = rand(355,340);

			// write
			imagettftext($src,$size,$angle,$x,$y,$color,$font,$letter);
		}

		// if not any fonts

	}
	else
	{
		// If folder of fonts is empty
		for($i = 0; $i<$security_num_letter; $i++){
		
			// reference point
			$h = 1;

			// Create code
			$color = imagecolorallocatealpha($src,rand(0,180),rand(0,180),rand(0,180),rand(10,30));
			$letter = $letters[rand(0,sizeof($letters) - 1)];

			if(empty($x)){
				$x = $security_width * 0.1;
			}
			else{
				$x = $x + ($security_width * 0.8) / $security_num_letter + rand(0,$security_width * 0.01);
			}

			if($h == rand(1,2))	{
				$y = (($security_height * 1) / 4) + rand(0,$security_height * 0.1);
			}
			else{
				$y = (($security_height * 1) / 4) - rand(0,$security_height * 0.1);
			}

			// Remember it
			$code[] = $letter;
			if($h == rand(0,10)) $letter = strtoupper($letter);

			// Write
			imagestring($src,9,$x,$y,$letter,$color);
		}
	}

	$securityCode = implode('',$code);

	// Remove all session from the DB which was added for latest 15 min
	$delete = "DELETE FROM ".DB_CAPTCHA." WHERE time < NOW() - INTERVAL '15' MINUTE";
	$dbh->query($delete);

	$query = "SELECT * FROM ".DB_CAPTCHA." WHERE id_session LIKE '".$_GET['sid']."'";
	$result = $dbh->query($query);

	// Save a code of captcha in DB
	if($result->num_rows > 0){
		$update = "UPDATE ".DB_CAPTCHA." SET securityCode = '".$securityCode."',
											 time = NOW()
					WHERE id_session = '".$_GET['sid']."'";

		$dbh->query($update);
	}
	else{
		$insert = "INSERT INTO ".DB_CAPTCHA." VALUES (0,'".$_GET['sid']."','$securityCode',NOW())";
		$dbh->query($insert);
	}

	// Clear the descriptor
	$result->close();

	// Close the DB connection
	$dbh->close();

	// Make the destruction of image
	$width = imagesx($src);
	$height = imagesy($src);

	$img2 = ImageCreateTrueColor($width, $height);

	$rand1 = mt_rand(700000, 1000000) / 15000000;
	$rand2 = mt_rand(700000, 1000000) / 15000000;
	$rand3 = mt_rand(700000, 1000000) / 15000000;
	$rand4 = mt_rand(700000, 1000000) / 15000000;

	$rand5 = mt_rand(0, 3141592) / 1000000;
	$rand6 = mt_rand(0, 3141592) / 1000000;
	$rand7 = mt_rand(0, 3141592) / 1000000;
	$rand8 = mt_rand(0, 3141592) / 1000000;

	$rand9 = mt_rand(400, 600) / 100;
	$rand10 = mt_rand(400, 600) / 100;

	for($x = 0; $x < $width; $x++) {
		for($y = 0; $y < $height; $y++){
			$sx = $x + (sin($x * $rand1 + $rand5) + sin($y * $rand3 + $rand6)) * $rand9;
			$sy = $y + (sin($x * $rand2 + $rand7) + sin($y * $rand4 + $rand8)) * $rand10;

			if($sx < 0 || $sy < 0 || $sx >= $width - 1 || $sy >= $height - 1){
				$color = 255;
				$color_x = 255;
				$color_y = 255;
				$color_xy = 255;
			}
			else{
				$color = (imagecolorat($src, $sx, $sy) >> 16) & 0xFF;
				$color_x = (imagecolorat($src, $sx + 1, $sy) >> 16) & 0xFF;
				$color_y = (imagecolorat($src, $sx, $sy + 1) >> 16) & 0xFF;
				$color_xy = (imagecolorat($src, $sx + 1, $sy + 1) >> 16) & 0xFF;
			}

			if($color == $color_x && $color == $color_y && $color == $color_xy){
				$newcolor = $color;
			}
			else{
				$frsx = $sx - floor($sx);
				$frsy = $sy - floor($sy);
				$frsx1 = 1 - $frsx;
				$frsy1 = 1 - $frsy;

				$newcolor = floor($color * $frsx1 * $frsy1 + $color_x * $frsx * $frsy1 + $color_y * $frsx1 * $frsy + $color_xy * $frsx * $frsy);
			}

			imagesetpixel($img2, $x, $y, imagecolorallocate($img2, $newcolor, $newcolor, $newcolor));
		}
	}

	imagedestroy($src);

	// Create the image in accordance with settings
	if($security_image_type == 'PNG'){
		header ("Content-type: image/png");
		imagepng($img2);
	}
	elseif($security_image_type == 'JPEG'){
		header ("Content-type: image/jpeg");
		imagejpeg($img2);
	}
	else{
		header ("Content-type: image/gif");
		imagegif($img2);
	}

	imagedestroy($img2);
}

?>